# QuadGK.jl

[![Coverage Status](https://coveralls.io/repos/github/JuliaMath/QuadGK.jl/badge.svg?branch=master)](https://coveralls.io/github/JuliaMath/QuadGK.jl?branch=master)

Documentation:
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaMath.github.io/QuadGK.jl/stable)
[![](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaMath.github.io/QuadGK.jl/dev)

This package provides support for one-dimensional numerical integration in Julia using adaptive
Gauss-Kronrod quadrature.
The code was originally part of Base Julia.  It supports integration of arbitrary numeric types,
including arbitrary precision (`BigFloat`), and even integration of arbitrary normed vector spaces
(e.g. matrix-valued integrands).

The package provides three basic functions: `quadgk`, `gauss`, and `kronrod`.
`quadgk` performs the integration, `gauss` computes Gaussian quadrature points and weights for integrating
over the interval [a, b], and `kronrod` computes Kronrod points, weights, and embedded Gaussian quadrature
weights for integrating over [-1, 1].   Typical usage looks like:
```jl
using QuadGK
integral, err = quadgk(x -> exp(-x^2), 0, 1, rtol=1e-8)
```
which computes the integral of exp(–x²) from x=0 to x=1 to a relative tolerance of 10⁻⁸, and returns the approximate `integral = 0.746824132812427` and error estimate `err = 7.887024366937112e-13` (which is actually smaller than the requested tolerance: convergence was very rapid because the integrand is smooth).

For more information, see the [documentation](https://JuliaMath.github.io/QuadGK.jl/stable).

# Adaptive Gauss-Kronrod quadrature routines (arbitrary precision),
# originally written and contributed to Julia by Steven G. Johnson, 2013.
#
# This file was formerly a part of Julia. License is MIT: http://julialang.org/license

"""
The `QuadGK` module implements 1d numerical integration by an adaptive Gauss–Kronrod algorithm.

The package provides three functions: `quadgk`, `gauss`, and `kronrod`.

* `quadgk` performs adaptive integration over arbitrary intervals
* `gauss` computes Gaussian quadrature points and weights for integrating over the interval [-1, 1]
* `kronrod` computes Kronrod points, weights, and embedded Gaussian quadrature weights for integrating over [-1, 1].

Typical usage looks like:
```julia
using QuadGK
integral, err = quadgk(x -> exp(-x^2), 0, 1, rtol=1e-8)
```
which computes the integral of exp(–x²) from x=0 to x=1 to a relative tolerance of 10⁻⁸,
and returns the approximate `integral = 0.746824132812427` and error estimate
`err = 7.887024366937112e-13`.
"""
module QuadGK

export quadgk, quadgk!,
       quadgk_count, quadgk_print,
       gauss, kronrod,
       alloc_segbuf,
       quadgk_segbuf, quadgk_segbuf!, quadgk_segbuf_count, quadgk_segbuf_print,
       BatchIntegrand

using DataStructures, LinearAlgebra
import Base.Order.Reverse

# an in-place integrand function f!(result, x) and
# temporary mutable data (e.g. arrays) of type R for evalrule
struct InplaceIntegrand{F,R,RI}
    f!::F

    # temporary arrays for evalrule
    fg::R
    fk::R
    Ig::R
    Ik::R
    fx::R
    Idiff::RI

    # final result array
    I::RI
end

InplaceIntegrand(f!::F, I::RI, fx::R) where {F,RI,R} =
    InplaceIntegrand{F,R,RI}(f!, similar(fx), similar(fx), similar(fx), similar(fx), fx, similar(I), I)

include("gausskronrod.jl")
include("evalrule.jl")
include("adapt.jl")
include("api.jl")
include("weightedgauss.jl")
include("batch.jl")

end # module QuadGK

# Constructing Gaussian quadrature weights for an
# arbitrary weight function and integration bounds.

# for numerical stability, we apply the usual Lanczos
# Gram–Schmidt procedure to the basis {T₀,T₁,T₂,…} of
# Chebyshev polynomials on [-1,1] rather than to the
# textbook monomial basis {1,x,x²,…}.

# evaluate Chebyshev polynomial p(x) with coefficients a[i]
# by a Clenshaw recurrence.
function chebeval(x, a)
    if length(a) ≤ 2
        length(a) == 1 && return a[1] + x * zero(a[1])
        return a[1]+x*a[2]
    end
    bₖ = a[end-1] + 2x*a[end]
    bₖ₊₁ = oftype(bₖ, a[end])
    for j = lastindex(a)-2:-1:2
        bⱼ = a[j] + 2x*bₖ - bₖ₊₁
        bₖ, bₖ₊₁ = bⱼ, bₖ
    end
    return a[1] + x*bₖ - bₖ₊₁
end

# if a[i] are coefficients of Chebyshev series, compute the coefficients xa (in-place)
# of the series multiplied by x, using recurrence xTₙ = 0.5 (Tₙ₊₁+Tₙ₋₁) for n > 0
function chebx!(xa, a)
    resize!(xa, length(a)+1)
    xa .= 0
    for n = 2:lastindex(a)
        c = 0.5*a[n]
        xa[n-1] += c
        xa[n+1] += c
    end
    if !isempty(a)
        xa[2] += a[1]
    end
    return xa
end

"""
    gauss(W, N, a, b; rtol=sqrt(eps), quad=quadgk)

Return a pair `(x, w)` of `N` quadrature points `x[i]` and weights `w[i]` to
integrate functions on the interval `(a, b)` multiplied by the weight function
`W(x)`.  That is, `sum(w .* f.(x))` approximates the integral `∫ W(x)f(x)dx`
from `a` to `b`.

This function performs `2N` numerical integrals of polynomials against `W(x)`
using the integration function `quad` (defaults to `quadgk`) with relative tolerance `rtol`
(which defaults to half of the precision `eps` of the endpoints).
This is followed by an O(N²) calculations. So, using a large order `N` is expensive.

If `W` has lots of singularities that make it hard to integrate numerically,
you may need to decrease `rtol`.   You can also pass in a specialized quadrature routine
via the `quad` keyword argument, which should accept arguments `quad(f,a,b,rtol=_,atol=_)`
similar to `quadgk`.  (This is useful if your weight function has discontinuities, in which
case you might want to break up the integration interval at the discontinuities.)

The precision of the calculations and return value is determined from the types of `a` and `b`.
"""
function gauss(W, N::Integer, a::Real,b::Real; rtol::Real=sqrt(eps(typeof(float(b-a)))), quad=quadgk)
    (isfinite(a) && isfinite(b)) || throw(ArgumentError("a finite interval is required"))

    # find the Jacobi matrix and apply the Golub–Welsh algorithm:
    J, xscale, wint = _jacobi(W, N, a, b, rtol, quad)
    x, w = gauss(J, wint)
    @. x = (x + 1) / xscale + a
    return (x, w)
end

"""
    kronrod(W, N, a, b; rtol=sqrt(eps), quad=quadgk)

Return a tuple `(x, w, wg)` of `N` quadrature points `x[i]` and weights `w[i]` to
integrate functions on the interval `(a, b)` multiplied by the weight function
`W(x)`, along with the weights `wg` of an embedded Gauss rule corresponding to `x[2:2:end]`,
similar to the `gauss(W, N, a, b)` function and analogous to `kronrod(N)` (which only
returns the `x ≤ 0` points for a constant weight function).

That is, `I = sum(w .* f.(x))` approximates the integral `∫ W(x)f(x)dx`
from `a` to `b`.  And an error estimate is `abs(I - Ig)`, where `Ig` is
the result `Ig = sum(wg .* f.(x[2:2:end]))` of the embedded Gauss rule.

This function performs `≈ 3N+3` numerical integrals of polynomials against `W(x)`
using the integration function `quad` (defaults to `quadgk`) with relative tolerance `rtol`
(which defaults to half of the precision `eps` of the endpoints).
This is followed by an O(N²) calculations. So, using a large order `N` is expensive.
"""
function kronrod(W, N::Integer, a::Real,b::Real; rtol::Real=sqrt(eps(typeof(float(b-a)))), quad=quadgk)
    (isfinite(a) && isfinite(b)) || throw(ArgumentError("a finite interval is required"))

    # find the Jacobi matrix and apply the Golub–Welsh algorithm:
    J, xscale, wint = _jacobi(W, div(3N+3,2), a, b, rtol, quad)
    x, w, wg = kronrod(J, N, wint)
    @. x = (x + 1) / xscale + a
    return (x, w, wg)
end

function _jacobi(W, N, a, b, rtol, quad)
    # Uses the Lanczos recurrence described in Trefethen & Bau,
    # Numerical Linear Algebra, to find the Jacobi matrix
    # (the 3-term recurrence) for W using O(N) integrals,
    # applied to Chebyshev basis:
    xscale = float(2/(b-a)) # scaling from (a,b) to (-1,1)
    T = typeof(xscale)
    α = zeros(T, N)
    β = zeros(T, N)
    q₀ = sizehint!(T[0], N+1) # 0 polynomial
    wint = first(quad(W, a, b, rtol=rtol))
    (wint isa Real && wint > 0) ||
        throw(ArgumentError("weight W must be real and positive"))
    atol = rtol*wint
    q₁ = sizehint!(T[1/sqrt(wint)],N+1) # normalized constant polynomial
    v = copy(q₀)
    for n = 1:N
        chebx!(v, q₁) # v = x * q₁
        α[n] = first(quad(a, b, rtol=rtol, atol=atol) do x
            t = (x-a)*xscale - 1
            W(x) * chebeval(t, q₁) * chebeval(t, v)
        end)
        n == N && break
        for j = 1:length(q₀); v[j] -= β[n]*q₀[j]; end
        for j = 1:length(q₁); v[j] -= α[n]*q₁[j]; end
        β[n+1] = sqrt(first(quad(a, b, rtol=rtol, atol=atol) do x
            W(x) * chebeval((x-a)*xscale - 1, v)^2
        end))
        v .*= inv(β[n+1])
        q₀,q₁,v = q₁,v,q₀
    end

    return SymTridiagonal(α, β[2:N]), xscale, wint
end

module QuadGKEnzymeExt

using QuadGK, Enzyme, LinearAlgebra

function Enzyme.EnzymeRules.augmented_primal(config, ofunc::Const{typeof(quadgk)}, ::Type{RT}, f, segs::Annotation{T}...; kws...) where {RT, T}
    prims = map(x->x.val, segs)

    retres, segbuf = if f isa Const
        if EnzymeRules.needs_primal(config)
            quadgk(f.val, prims...; kws...), nothing
        else
            nothing
        end
    else
        I, E, segbuf = quadgk_segbuf(f.val, prims...; kws...)
        if EnzymeRules.needs_primal(config)
            (I, E), segbuf
        else
            nothing, segbuf
        end
    end

    dres = if !Enzyme.EnzymeRules.needs_shadow(config)
        nothing
    elseif EnzymeRules.width(config) == 1
        zero.(res...)
    else
        ntuple(Val(EnzymeRules.width(config))) do i
            Base.@_inline_meta
            zero.(res...)
        end
    end

    cache = if RT <: Duplicated || RT <: DuplicatedNoNeed || RT <: BatchDuplicated || RT <: BatchDuplicatedNoNeed
        dres
    else
        nothing
    end
    cache2 = segbuf, cache

    return Enzyme.EnzymeRules.AugmentedReturn{
        Enzyme.EnzymeRules.needs_primal(config) ? eltype(RT) : Nothing,
        Enzyme.EnzymeRules.needs_shadow(config) ? (Enzyme.EnzymeRules.width(config) == 1 ? eltype(RT) : NTuple{Enzyme.EnzymeRules.width(config), eltype(RT)}) : Nothing,
        typeof(cache2)
    }(retres, dres, cache2)
end

function call(f, x)
    f(x)
end

# Wrapper around a function f that allows it to act as a vector space, and hence be usable as
# an integrand, where the vector operations act on the closed-over parameters of f that are
# begin differentiated with respect to.   In particular, if we have a closure f = x -> g(x, p), and we want
# to differentiate with respect to p, then our reverse (vJp) rule needs an integrand given by the
# Jacobian-vector product (pullback) vᵀ∂g/∂p.  But Enzyme wraps this in a closure so that it is the
# same "shape" as f, whereas to integrate it we need to be able to treat it as a vector space.
# ClosureVector calls Enzyme.Compiler.recursive_add, which is an internal function that "unwraps"
# the closure to access the internal state, which can then be added/subtracted/scaled.
struct ClosureVector{F}
    f::F
end

@inline function guaranteed_nonactive(::Type{T}) where T
    rt = Enzyme.Compiler.active_reg_inner(T, (), nothing)
    return rt == Enzyme.Compiler.AnyState || rt == Enzyme.Compiler.DupState
end

function Base.:+(a::CV, b::CV) where {CV <: ClosureVector}
    Enzyme.Compiler.recursive_add(a, b, identity, guaranteed_nonactive)::CV
end

function Base.:-(a::CV, b::CV) where {CV <: ClosureVector}
    Enzyme.Compiler.recursive_add(a, b, x->-x, guaranteed_nonactive)::CV
end

function Base.:*(a::Number, b::CV) where {CV <: ClosureVector}
    # b + (a-1) * b = a * b
    Enzyme.Compiler.recursive_add(b, b, x->(a-1)*x, guaranteed_nonactive)::CV
end

function Base.:*(a::ClosureVector, b::Number)
    return b*a
end

function Enzyme.EnzymeRules.reverse(config, ofunc::Const{typeof(quadgk)}, dres::Active, cache, f::Union{Const, Active}, segs::Annotation{T}...; kws...) where {T}
    df = if f isa Const
        nothing
    else
        segbuf = cache[1]
        fwd, rev = Enzyme.autodiff_thunk(ReverseSplitNoPrimal, Const{typeof(call)}, Active, typeof(f), Const{T})
        _df, _ = quadgk(map(x->x.val, segs)...; kws..., eval_segbuf=segbuf, maxevals=0, norm=f->0) do x
            tape, prim, shad = fwd(Const(call), f, Const(x))
            drev = rev(Const(call), f, Const(x), dres.val[1], tape)
            return ClosureVector(drev[1][1])
        end
        _df.f
    end
    dsegs1 = segs[1] isa Const ? nothing : -LinearAlgebra.dot(f.val(segs[1].val), dres.val[1])
    dsegsn = segs[end] isa Const ? nothing : LinearAlgebra.dot(f.val(segs[end].val), dres.val[1])
    return (df, # f
            dsegs1,
            ntuple(i -> nothing, Val(length(segs)-2))...,
            dsegsn)
end

function Enzyme.EnzymeRules.reverse(config, ofunc::Const{typeof(quadgk)}, dres::Type{<:Union{Duplicated, BatchDuplicated}}, cache, f::Union{Const, Active}, segs::Annotation{T}...; kws...) where {T}
    dres = cache[2]
    df = if f isa Const
        nothing
    else
        segbuf = cache[1]
        fwd, rev = Enzyme.autodiff_thunk(ReverseSplitNoPrimal, Const{typeof(call)}, Active, typeof(f), Const{T})
        _df, _ = quadgk(map(x->x.val, segs)...; kws..., eval_segbuf=segbuf, maxevals=0, norm=f->0) do x
            tape, prim, shad = fwd(Const(call), f, Const(x))
            shad .= dres
            drev = rev(Const(call), f, Const(x), tape)
            return ClosureVector(drev[1][1])
        end
        _df.f
    end
    dsegs1 = segs[1] isa Const ? nothing : -LinearAlgebra.dot(f.val(segs[1].val), dres)
    dsegsn = segs[end] isa Const ? nothing : LinearAlgebra.dot(f.val(segs[end].val), dres)
    Enzyme.make_zero!(dres)
    return (df, # f
            dsegs1,
            ntuple(i -> nothing, Val(length(segs)-2))...,
            dsegsn)
end

end # module

# integration segment (a,b), estimated integral I, and estimated error E
struct Segment{TX,TI,TE}
    a::TX
    b::TX
    I::TI
    E::TE
end
Base.@pure Base.promote_rule(::Type{Segment{TX,TI,TE}}, ::Type{Segment{TX′,TI′,TE′}}) where {TX,TI,TE,TX′,TI′,TE′} =
    Segment{promote_type(TX,TX′), promote_type(TI,TI′), promote_type(TE,TE′)}
Base.convert(::Type{T}, s::Segment) where {T<:Segment} = T(s.a,s.b,s.I,s.E)
Base.:(==)(s1::Segment, s2::Segment) = s1.a == s2.a && s1.b == s2.b && s1.I == s2.I && s1.E == s2.E
Base.isless(i::Segment, j::Segment) = isless(i.E, j.E)
Segment(a::Number, b::Number) = Segment(promote(a, b)..., nothing, nothing)

# Internal routine: approximately integrate f(x) over the interval (a,b)
# by evaluating the integration rule (x,w,wg). Return a Segment.
function evalrule(f::F, a,b, x,w,wg, nrm) where {F}
    # Ik and Ig are integrals via Kronrod and Gauss rules, respectively
    s = convert(eltype(x), 0.5) * (b-a)
    n1 = 1 - (length(x) & 1) # 0 if even order, 1 if odd order
    if n1 == 0 # even: Gauss rule does not include x == 0
        Ik = f(a + s) * w[end]
        Ig = zero(Ik)
    else # odd: don't count x==0 twice in Gauss rule
        f0 = f(a + s)
        Ig = f0 * wg[end]
        Ik = f0 * w[end] +
            (f(a + (1+x[end-1])*s) + f(a + (1-x[end-1])*s)) * w[end-1]
    end
    for i = 1:length(wg)-n1
        fg = f(a + (1+x[2i])*s) + f(a + (1-x[2i])*s)
        fk = f(a + (1+x[2i-1])*s) + f(a + (1-x[2i-1])*s)
        Ig += fg * wg[i]
        Ik += fg * w[2i] + fk * w[2i-1]
    end
    Ik_s, Ig_s = Ik * s, Ig * s # new variable since this may change the type
    E = nrm(Ik_s - Ig_s)
    if isnan(E) || isinf(E)
        throw(DomainError(a+s, "integrand produced $E in the interval ($a, $b)"))
    end
    return Segment(oftype(s, a), oftype(s, b), Ik_s, E)
end

# compute result = f(x1) + f(x2) in-place
function eval2x!(result, f::InplaceIntegrand{F}, x1, x2) where {F}
    f.f!(result, x1)
    f.f!(f.fx, x2)
    result .+= f.fx
end

# as above, but call assume a mutable result type (e.g. an array) and
# act in-place using `f!(result, x)`.
function evalrule(f::InplaceIntegrand{F}, a,b, x,w,wg, nrm) where {F}
    # Ik and Ig are integrals via Kronrod and Gauss rules, respectively
    s = convert(eltype(x), 0.5) * (b-a)
    n1 = 1 - (length(x) & 1) # 0 if even order, 1 if odd order
    fg, fk, Ig, Ik = f.fg, f.fk, f.Ig, f.Ik # pre-allocated temporary arrays
    f.f!(f.fx, a + s)
    if n1 == 0 # even: Gauss rule does not include x == 0
        Ik .= f.fx .* w[end]
        Ig .= zero.(Ik)
    else # odd: don't count x==0 twice in Gauss rule
        Ig .= f.fx .* wg[end]
        f.f!(fg, a + (1+x[end-1])*s)
        f.f!(fk, a + (1-x[end-1])*s)
        Ik .= f.fx .* w[end] .+ (fg .+ fk) .* w[end-1]
    end
    for i = 1:length(wg)-n1
        eval2x!(fg, f, a + (1+x[2i])*s, a + (1-x[2i])*s)
        eval2x!(fk, f, a + (1+x[2i-1])*s, a + (1-x[2i-1])*s)
        Ig .+= fg .* wg[i]
        Ik .+= fg .* w[2i] .+ fk .* w[2i-1]
    end
    Ik_s = Ik * s # new variable since this may change the type
    f.Idiff .= Ik_s .- Ig .* s
    E = nrm(f.Idiff)
    if isnan(E) || isinf(E)
        throw(DomainError(a+s, "integrand produced $E in the interval ($a, $b)"))
    end
    return Segment(oftype(s, a), oftype(s, b), Ik_s, E)
end

"""
    BatchIntegrand(f!, y::AbstractVector, [x::AbstractVector]; max_batch=typemax(Int))
    BatchIntegrand{Y,X}(f!; max_batch=typemax(Int)) where {Y,X}
    BatchIntegrand{Y}(f!; max_batch=typemax(Int)) where {Y}

Constructor for a `BatchIntegrand` accepting an integrand of the form `f!(y,x) = y .= f.(x)`
that can evaluate the integrand at multiple quadrature nodes using, for example, threads,
the GPU, or distributed memory. The arguments `y`, and optionally `x`, are pre-allocated
buffers of the correct element type for the domain and range of `f!`. Additionally, they
must be `resize!`-able since the number of evaluation points may vary between calls to `f!`.
Alternatively, the element types of those buffers, `Y` and optionally `X`, may be passed as
type parameters to the constructor. The `max_batch` keyword roughly limits the number of
nodes passed to the integrand, though at least `4*order+2` nodes will be used by the GK
rule.

## Internal allocations

If `x` or `X` are not specified, `quadgk` internally creates a new `BatchIntegrand` with the
user-supplied `y` buffer and a freshly-allocated `x` buffer based on the domain types. So,
if you want to reuse the `x` buffer between calls, supply `{Y,X}` or pass `y,x` explicitly.
"""
struct BatchIntegrand{Y,X,Ty<:AbstractVector{Y},Tx<:AbstractVector{X},F}
    # in-place function f!(y, x) that takes an array of x values and outputs an array of results in-place
    f!::F
    y::Ty
    x::Tx
    max_batch::Int # maximum number of x to supply in parallel
end

function BatchIntegrand(f!, y::AbstractVector, x::AbstractVector=similar(y, Nothing); max_batch::Integer=typemax(Int))
    max_batch > 0 || throw(ArgumentError("max_batch must be positive"))
    return BatchIntegrand(f!, y, x, max_batch)
end
BatchIntegrand{Y,X}(f!; kws...) where {Y,X} = BatchIntegrand(f!, Y[], X[]; kws...)
BatchIntegrand{Y}(f!; kws...) where {Y} = BatchIntegrand(f!, Y[]; kws...)

function batchevalrule(fx::AbstractVector{T}, a,b, x,w,wg, nrm) where {T}
    l = length(x)
    n = 2l - 1 # number of Kronrod points
    n1 = 1 - (l & 1) # 0 if even order, 1 if odd order
    s = convert(eltype(x), 0.5) * (b-a)
    if n1 == 0 # even: Gauss rule does not include x == 0
        Ik = fx[l] * w[end]
        Ig = zero(Ik)
    else # odd: don't count x==0 twice in Gauss rule
        f0 = fx[l]
        Ig = f0 * wg[end]
        Ik = f0 * w[end] + (fx[l-1] + fx[l+1]) * w[end-1]
    end
    for i = 1:length(wg)-n1
        fg = fx[2i] + fx[n-2i+1]
        fk = fx[2i-1] + fx[n-2i+2]
        Ig += fg * wg[i]
        Ik += fg * w[2i] + fk * w[2i-1]
    end
    Ik_s, Ig_s = Ik * s, Ig * s # new variable since this may change the type
    E = nrm(Ik_s - Ig_s)
    if isnan(E) || isinf(E)
        throw(DomainError(a+s, "integrand produced $E in the interval ($a, $b)"))
    end
    return Segment(oftype(s, a), oftype(s, b), Ik_s, E)
end

function evalrules(f::BatchIntegrand, s::NTuple{N}, x,w,wg, nrm) where {N}
    l = length(x)
    m = 2l-1    # evaluations per segment
    n = (N-1)*m # total evaluations
    resize!(f.x, n)
    resize!(f.y, n)
    for i in 1:(N-1)    # fill buffer with evaluation points
        a = s[i]; b = s[i+1]
        c = convert(eltype(x), 0.5) * (b-a)
        o = (i-1)*m
        f.x[l+o] = a + c
        for j in 1:l-1
            f.x[j+o] = a + (1 + x[j]) * c
            f.x[m+1-j+o] = a + (1 - x[j]) * c
        end
    end
    f.f!(f.y, f.x)  # evaluate integrand
    return ntuple(Val(N-1)) do i
        return batchevalrule(view(f.y, (1+(i-1)*m):(i*m)), s[i], s[i+1], x,w,wg, nrm)
    end
end

# for evalrules, evaluate at points from `eval_segs` segments, storing in f.y,
# returning the number m of evaluations per segment.
function eval_integrand_from_segs!(f::BatchIntegrand, eval_segs::AbstractVector, x,w,wg, nrm)
    l = length(x)
    m = 2l-1    # evaluations per segment
    n = length(eval_segs)*m # total evaluations
    resize!(f.x, n)
    resize!(f.y, n)
    for i in eachindex(eval_segs) # fill buffer with evaluation points
        @inbounds a, b = eval_segs[i].a, eval_segs[i].b
        c = convert(eltype(x), 0.5) * (b-a)
        o = (i-firstindex(eval_segs))*m
        f.x[l+o] = a + c
        for j in 1:l-1
            f.x[j+o] = a + (1 + x[j]) * c
            f.x[m+1-j+o] = a + (1 - x[j]) * c
        end
    end
    f.f!(f.y, f.x)  # evaluate integrand
    return m
end

# eval rules for a vector `eval_segs` of segments, mutating segs in-place
function evalrules!(segs::AbstractVector, f::BatchIntegrand, eval_segs::AbstractVector, x,w,wg, nrm)
    axes(segs, 1) == axes(eval_segs, 1) || throw(DimensionMismatch())
    m = eval_integrand_from_segs!(f, eval_segs, x,w,wg, nrm)
    for i in 1:length(segs)
        @inbounds a, b = eval_segs[i].a, eval_segs[i].b
        segs[i] = batchevalrule(view(f.y, (1+(i-1)*m):(i*m)), a,b, x,w,wg, nrm)
    end
    return segs
end

# eval rules for a vector `eval_segs` of segments
function evalrules(f::BatchIntegrand, eval_segs::Vector, x,w,wg, nrm)
    m = eval_integrand_from_segs!(f, eval_segs, x,w,wg, nrm)
    return map(1:length(eval_segs)) do i
        @inbounds a, b = eval_segs[i].a, eval_segs[i].b
        batchevalrule(view(f.y, (1+(i-1)*m):(i*m)), a,b, x,w,wg, nrm)
    end
end

# we refine as many segments as we can fit into the buffer
function refine(f::BatchIntegrand, segs::Vector{T}, I, E, numevals, x,w,wg,n, atol, rtol, maxevals, nrm) where {T}
    tol = max(atol, rtol*nrm(I))
    nsegs = 0
    len = length(segs)
    l = length(x)
    m = 2l-1 # == 2n+1

    # collect as many segments that will have to be evaluated for the current tolerance
    # while staying under max_batch and maxevals
    while len > nsegs && 2m*nsegs < f.max_batch && E > tol && numevals < maxevals
        # same as heappop!, but moves segments to end of heap/vector to avoid allocations
        s = segs[1]
        y = segs[len-nsegs]
        segs[len-nsegs] = s
        nsegs += 1
        tol += s.E
        numevals += 2m
        len > nsegs && DataStructures.percolate_down!(segs, 1, y, Reverse, len-nsegs)
    end

    resize!(f.x, 2m*nsegs)
    resize!(f.y, 2m*nsegs)
    for i in 1:nsegs    # fill buffer with evaluation points
        s = segs[len-i+1]
        mid = (s.a+s.b)/2
        for (j,a,b) in ((2,s.a,mid), (1,mid,s.b))
            check_endpoint_roundoff(a, b, x) && return segs
            c = convert(eltype(x), 0.5) * (b-a)
            o = (2i-j)*m
            f.x[l+o] = a + c
            for k in 1:l-1
                # early return if integrand evaluated at endpoints
                f.x[k+o] = a + (1 + x[k]) * c
                f.x[m+1-k+o] = a + (1 - x[k]) * c
            end
        end
    end
    f.f!(f.y, f.x)

    resize!(segs, len+nsegs)
    for i in 1:nsegs    # evaluate segments and update estimates & heap
        s = segs[len-i+1]
        mid = (s.a + s.b)/2
        s1 = batchevalrule(view(f.y, 1+2(i-1)*m:(2i-1)*m), s.a,mid, x,w,wg, nrm)
        s2 = batchevalrule(view(f.y, 1+(2i-1)*m:2i*m), mid,s.b, x,w,wg, nrm)
        I = (I - s.I) + s1.I + s2.I
        E = (E - s.E) + s1.E + s2.E
        segs[len-i+1] = s1
        segs[len+i]   = s2
    end
    for i in 1:2nsegs
        DataStructures.percolate_up!(segs, len-nsegs+i, Reverse)
    end

    return I, E, numevals
end

function handle_infinities(workfunc, f::BatchIntegrand, s)
    s1, s2 = s[1], s[end]
    if realone(s1) && realone(s2) # check for infinite or semi-infinite intervals
        inf1, inf2 = isinf(s1), isinf(s2)
        if inf1 || inf2
            xtmp = f.x # buffer to store evaluation points
            ytmp = f.y # original integrand may have different units
            xbuf = similar(xtmp, typeof(one(eltype(f.x))))
            ybuf = similar(ytmp, typeof(oneunit(eltype(f.y))*oneunit(s1)))
            if inf1 && inf2 # x = t/(1-t^2) coordinate transformation
                return workfunc(BatchIntegrand((v, t) -> begin resize!(xtmp, length(t)); resize!(ytmp, length(v));
                                            f.f!(ytmp, xtmp .= oneunit(s1) .* t ./ (1 .- t .* t)); v .= ytmp .* (1 .+ t .* t) .* oneunit(s1) ./ (1 .- t .* t) .^ 2; end, ybuf, xbuf, f.max_batch),
                                map(x -> isinf(x) ? (signbit(x) ? -one(x) : one(x)) : 2x / (oneunit(x)+hypot(oneunit(x),2x)), s),
                                t -> oneunit(s1) * t / (1 - t^2))
            end
            let (s0,si) = inf1 ? (s2,s1) : (s1,s2) # let is needed for JuliaLang/julia#15276
                if si < zero(si) # x = s0 - t/(1-t)
                    return workfunc(BatchIntegrand((v, t) -> begin resize!(xtmp, length(t)); resize!(ytmp, length(v));
                                            f.f!(ytmp, xtmp .= s0 .- oneunit(s1) .* t ./ (1 .- t)); v .= ytmp .* oneunit(s1) ./ (1 .- t) .^ 2; end, ybuf, xbuf, f.max_batch),
                                    reverse(map(x -> 1 / (1 + oneunit(x) / (s0 - x)), s)),
                                    t -> s0 - oneunit(s1)*t/(1-t))
                else # x = s0 + t/(1-t)
                    return workfunc(BatchIntegrand((v, t) -> begin resize!(xtmp, length(t)); resize!(ytmp, length(v));
                                            f.f!(ytmp, xtmp .= s0 .+ oneunit(s1) .* t ./ (1 .- t)); v .= ytmp .* oneunit(s1) ./ (1 .- t) .^ 2; end, ybuf, xbuf, f.max_batch),
                                    map(x -> 1 / (1 + oneunit(x) / (x - s0)), s),
                                    t -> s0 + oneunit(s1)*t/(1-t))
                end
            end
        end
    end
    return workfunc(f, s, identity)
end

"""
    quadgk(f::BatchIntegrand, a,b,c...; kws...)

Like [`quadgk`](@ref), but batches evaluation points for an in-place integrand to evaluate
simultaneously. In particular, there are two differences from `quadgk`

1. The function `f.f!` should be of the form `f!(y, x) = y .= f.(x)`.  That is, it writes
   the return values of the integand `f(x)` in-place into its first argument `y`. (The
   return value of `f!` is ignored.) See [`BatchIntegrand`](@ref) for how to define the
   integrand.

2. `f.max_batch` changes how the adaptive refinement is done by batching multiple segments
   together. Choosing `max_batch<=4*order+2` will reproduce the result of
   non-batched `quadgk`, however if `max_batch=n*(4*order+2)` up to `2n` Kronrod rules will be evaluated
   together, which can produce slightly different results and sometimes require more
   integrand evaluations when using relative tolerances.
"""
function quadgk(f::BatchIntegrand{Y,Nothing}, a::T,b::T,c::T...; kws...) where {Y,T}
    FT = float(T) # the gk points are floating-point
    g = BatchIntegrand(f.f!, f.y, similar(f.x, FT), f.max_batch)
    return quadgk(g, a,b,c...; kws...)
end

# This can be wrapped around the `segbuf` argument
# of do_quadgk to indicate that the segment buffer
# should be saved and returned as an extra return value.
# (Helps us re-use do_quadgk for both cases, while
#  remaining type-stable despite the varying return value.)
struct ReturnSegbuf{S<:Union{Nothing,<:AbstractVector{<:Segment}}}
    segbuf::S # either a pre-allocateed segment buffer or nothing
end

# Internal routine: integrate f over the union of the open intervals
# (s[1],s[2]), (s[2],s[3]), ..., (s[end-1],s[end]), using h-adaptive
# integration with the order-n Kronrod rule and weights of type Tw,
# with absolute tolerance atol and relative tolerance rtol,
# with maxevals an approximate maximum number of f evaluations.
function do_quadgk(f::F, s::NTuple{N,T}, n, atol, rtol, maxevals, nrm,
                   _segbuf::Union{Nothing,<:AbstractVector{<:Segment},ReturnSegbuf},
                   eval_segbuf::Union{Nothing,<:AbstractVector{<:Segment}}) where {T,N,F}
    x,w,wg = cachedrule(T,n)
    segbuf = _segbuf isa ReturnSegbuf ? _segbuf.segbuf : _segbuf
    isnothing(segbuf) || Base.require_one_based_indexing(segbuf)

    if !isnothing(eval_segbuf) # contains initial quadrature intervals
        Base.require_one_based_indexing(eval_segbuf)
        isempty(eval_segbuf) && throw(ArgumentError("eval_segbuf must be non-empty"))
        if f isa BatchIntegrand
            if isnothing(segbuf)
                segbuf2 = evalrules(f, eval_segbuf, x,w,wg, nrm)
            else
                segbuf2 = evalrules!(resize!(segbuf, length(eval_segbuf)),
                                     f, eval_segbuf, x,w,wg, nrm)
            end
        else
            if isnothing(segbuf)
                segbuf2 = map(eval_segbuf) do seg
                    evalrule(f, seg.a, seg.b, x,w,wg, nrm)
                end
            else
                segbuf2 = map!(resize!(segbuf, length(eval_segbuf)), eval_segbuf) do seg
                    evalrule(f, seg.a, seg.b, x,w,wg, nrm)
                end
            end
        end

        I, E = resum(f, segbuf2)
        numevals = (2n+1) * length(segbuf2)
    else
        @assert N ≥ 2
        if f isa BatchIntegrand
            segs = evalrules(f, s, x,w,wg, nrm)
        else
            segs = ntuple(Val{N-1}()) do i
                a, b = s[i], s[i+1]
                evalrule(f, a,b, x,w,wg, nrm)
            end
        end

        I, E = resum(f, segs)
        numevals = (2n+1) * (N-1)

        # save segs into segbuf if !== nothing, both for adaptive subdivision
        # and to return to the user for re-using with different integrands:
        isnothing(segbuf) || (resize!(segbuf, N-1) .= segs)
        segbuf2 = segbuf # to mirror eval_segbuf branch above
    end

    # logic here is mainly to handle dimensionful quantities: we
    # don't know the correct type of atol115, in particular, until
    # this point where we have the type of E from f.  Also, follow
    # Base.isapprox in that if atol≠0 is supplied by the user, rtol
    # defaults to zero.
    atol_ = something(atol, zero(E))
    rtol_ = something(rtol, iszero(atol_) ? sqrt(eps(one(eltype(x)))) : zero(eltype(x)))

    # optimize common case of no subdivision
    if numevals ≥ maxevals || E ≤ atol_ || E ≤ rtol_ * nrm(I)
        # fast return when no subdivisions required
        if _segbuf isa ReturnSegbuf
            return (I, E, isnothing(segbuf2) ? collect(segs) : segbuf2)
        else
            return (I, E)
        end
    end

    segheap = segbuf2 === nothing ? collect(segs) : segbuf2
    heapify!(segheap, Reverse)
    I, E = resum(f, adapt(f, segheap, I, E, numevals, x,w,wg,n, atol_, rtol_, maxevals, nrm))
    return _segbuf isa ReturnSegbuf ? (I, E, segheap) : (I, E)
end

# internal routine to perform the h-adaptive refinement of the integration segments (segs)
function adapt(f::F, segs::Vector{T}, I, E, numevals, x,w,wg,n, atol, rtol, maxevals, nrm) where {F, T}
    # Pop the biggest-error segment and subdivide (h-adaptation)
    # until convergence is achieved or maxevals is exceeded.
    while E > atol && E > rtol * nrm(I) && numevals < maxevals
        next = refine(f, segs, I, E, numevals, x,w,wg,n, atol, rtol, maxevals, nrm)
        next isa Vector && return next # handle type-unstable functions
        I, E, numevals = next
    end
    return segs
end

# internal routine to refine the segment with largest error
function refine(f::F, segs::Vector{T}, I, E, numevals, x,w,wg,n, atol, rtol, maxevals, nrm) where {F, T}
    s = heappop!(segs, Reverse)
    mid = (s.a + s.b) / 2

    # early return if integrand evaluated at endpoints
    if check_endpoint_roundoff(s.a, mid, x) || check_endpoint_roundoff(mid, s.b, x)
        heappush!(segs, s, Reverse)
        return segs
    end

    s1 = evalrule(f, s.a, mid, x,w,wg, nrm)
    s2 = evalrule(f, mid, s.b, x,w,wg, nrm)

    if f isa InplaceIntegrand
        I .= (I .- s.I) .+ s1.I .+ s2.I
    else
        I = (I - s.I) + s1.I + s2.I
    end
    E = (E - s.E) + s1.E + s2.E
    numevals += 4n+2

    # handle type-unstable functions by converting to a wider type if needed
    Tj = promote_type(typeof(s1), promote_type(typeof(s2), T))
    if Tj !== T
        return adapt(f, heappush!(heappush!(Vector{Tj}(segs), s1, Reverse), s2, Reverse),
                     I, E, numevals, x,w,wg,n, atol, rtol, maxevals, nrm)
    end

    heappush!(segs, s1, Reverse)
    heappush!(segs, s2, Reverse)

    return I, E, numevals
end

# re-sum (paranoia about accumulated roundoff)
function resum(f, segs)
    if f isa InplaceIntegrand
        I = f.I .= segs[1].I
        E = segs[1].E
        for i in 2:length(segs)
            I .+= segs[i].I
            E += segs[i].E
        end
    else
        I = segs[1].I
        E = segs[1].E
        for i in 2:length(segs)
            I += segs[i].I
            E += segs[i].E
        end
    end
    return (I, E)
end

realone(x) = false
realone(x::Number) = one(x) isa Real

# transform f and the endpoints s to handle infinite intervals, if any,
# and pass transformed data to workfunc(f, s, tfunc)
function handle_infinities(workfunc, f, s)
    s1, s2 = s[1], s[end]
    if realone(s1) && realone(s2) # check for infinite or semi-infinite intervals
        inf1, inf2 = isinf(s1), isinf(s2)
        if inf1 || inf2
            if inf1 && inf2 # x = t/(1-t^2) coordinate transformation
                return workfunc(t -> begin t2 = t*t; den = 1 / (1 - t2);
                                            f(oneunit(s1)*t*den) * (1+t2)*den*den*oneunit(s1); end,
                                map(x -> isinf(x) ? (signbit(x) ? -one(x) : one(x)) : 2x / (oneunit(x)+hypot(oneunit(x),2x)), s),
                                t -> oneunit(s1) * t / (1 - t^2))
            end
            let (s0,si) = inf1 ? (s2,s1) : (s1,s2) # let is needed for JuliaLang/julia#15276
                if si < zero(si) # x = s0 - t/(1-t)
                    return workfunc(t -> begin den = 1 / (1 - t);
                                                f(s0 - oneunit(s1)*t*den) * den*den*oneunit(s1); end,
                                    reverse(map(x -> x == s0 ? zero(x) : isinf(x) ? one(x) : 1 / (1 + oneunit(x) / (s0 - x)), s)),
                                    t -> s0 - oneunit(s1)*t/(1-t))
                else # x = s0 + t/(1-t)
                    return workfunc(t -> begin den = 1 / (1 - t);
                                                f(s0 + oneunit(s1)*t*den) * den*den*oneunit(s1); end,
                                    map(x -> x == s0 ? zero(x) : isinf(x) ? one(x) : 1 / (1 + oneunit(x) / (x - s0)), s),
                                    t -> s0 + oneunit(s1)*t/(1-t))
                end
            end
        end
    end
    return workfunc(f, s, identity)
end

function handle_infinities(workfunc, f::InplaceIntegrand, s)
    s1, s2 = s[1], s[end]
    if realone(s1) && realone(s2) # check for infinite or semi-infinite intervals
        inf1, inf2 = isinf(s1), isinf(s2)
        if inf1 || inf2
            ftmp = f.fx # original integrand may have different units
            if inf1 && inf2 # x = t/(1-t^2) coordinate transformation
                return workfunc(InplaceIntegrand((v, t) -> begin t2 = t*t; den = 1 / (1 - t2);
                                            f.f!(ftmp, oneunit(s1)*t*den); v .= ftmp .* ((1+t2)*den*den*oneunit(s1)); end, f.I, f.fx * oneunit(s1)),
                                map(x -> isinf(x) ? (signbit(x) ? -one(x) : one(x)) : 2x / (oneunit(x)+hypot(oneunit(x),2x)), s),
                                t -> oneunit(s1) * t / (1 - t^2))
            end
            let (s0,si) = inf1 ? (s2,s1) : (s1,s2) # let is needed for JuliaLang/julia#15276
                if si < zero(si) # x = s0 - t/(1-t)
                    return workfunc(InplaceIntegrand((v, t) -> begin den = 1 / (1 - t);
                                            f.f!(ftmp, s0 - oneunit(s1)*t*den); v .= ftmp .* (den * den * oneunit(s1)); end, f.I, f.fx * oneunit(s1)),
                                    reverse(map(x -> x == s0 ? zero(x) : isinf(x) ? one(x) : 1 / (1 + oneunit(x) / (s0 - x)), s)),
                                    t -> s0 - oneunit(s1)*t/(1-t))
                else # x = s0 + t/(1-t)
                    return workfunc(InplaceIntegrand((v, t) -> begin den = 1 / (1 - t);
                                            f.f!(ftmp, s0 + oneunit(s1)*t*den); v .= ftmp .* (den * den * oneunit(s1)); end, f.I, f.fx * oneunit(s1)),
                                    map(x -> x == s0 ? zero(x) : isinf(x) ? one(x) : 1 / (1 + oneunit(x) / (x - s0)), s),
                                    t -> s0 + oneunit(s1)*t/(1-t))
                end
            end
        end
    end
    return workfunc(f, s, identity)
end

function check_endpoint_roundoff(a, b, x)
    c = convert(eltype(x), 0.5) * (b-a)
    eval_at_a = a == a + (1+x[1])*c
    eval_at_b = b == a + (1-x[1])*c
    return eval_at_a || eval_at_b
end

###########################################################################
# Gauss-Kronrod integration-weight computation for arbitrary floating-point
# types and precision, implemented based on the description in:
#
#    Dirk P. Laurie, "Calculation of Gauss-Kronrod quadrature rules,"
#    Mathematics of Computation, vol. 66, no. 219, pp. 1133-1145 (1997).
#
# for the Kronrod rule, and for the Gauss rule from the description in
#
#    Lloyd N. Trefethen and David Bau, Numerical Linear Algebra (SIAM, 1997).
#
# Arbitrary-precision eigenvalue (eignewt & eigpoly) and eigenvector
# (eigvec1) routines are written by SGJ, independent of the above sources.
#
# Another useful reference is the review article:
#
#    Sotirios E. Notaris, "Gauss–Kronrod quadrature formulae —
#    A survey of fifty years of research," Electronic Transactions
#    on Numerical Analysis vol. 45, pp. 374–404 (2016).
#    https://etna.ricam.oeaw.ac.at/vol.45.2016/pp371-404.dir/pp371-404.pdf

###########################################################################
# Eigensolver utilities:

# Implement a type for symmetric tridiagonal matrices with zero diagonals:
#
# For the common case of Gauss-Kronrod rules for the unit weight function,
# the diagonals of the Jacobi matrices are zero and certain things simplify
# compared to the general case of an arbitrary weight function.

# a type for us to dispatch on; we don't actually need the full AbstractMatrix functionality
"""
    QuadGK.HollowSymTridiagonal(ev::AbstractVector)

Construct a "hollow" symmetric tridiagonal matrix, whose diagonal entries are zero and
whose first sub/super-diagonal is `ev`.

The `HollowSymTridiagonal` type can be passed to [`gauss`](@ref) or [`kronrod`](@ref) for
Jacobi matrices to dispatch to specialized methods that exploit the special "hollow" structure
arising for symmetric weight functions, in order to generate symmetric quadrature rules more efficiently.
"""
struct HollowSymTridiagonal{T, V<:AbstractVector{T}} <: AbstractMatrix{T}
    ev::V # superdiagonal
    function HollowSymTridiagonal{T, V}(ev) where {T, V<:AbstractVector{T}}
        Base.require_one_based_indexing(ev)
        return new{T, V}(ev)
    end
end
HollowSymTridiagonal(ev::AbstractVector{T}) where {T} =
    HollowSymTridiagonal{T,typeof(ev)}(ev)
Base.size(A::HollowSymTridiagonal) = (length(A.ev)+1,length(A.ev)+1)
LinearAlgebra.diag(A::HollowSymTridiagonal) = zeros(eltype(A), size(A,1))
LinearAlgebra.SymTridiagonal(A::HollowSymTridiagonal{T}) where {T} = SymTridiagonal{T}(A)
LinearAlgebra.SymTridiagonal{T}(A::HollowSymTridiagonal) where {T} = SymTridiagonal(zeros(T, length(A.ev)+1), Vector{T}(A.ev))
function HollowSymTridiagonal(A::SymTridiagonal)
    iszero(A.dv) || throw(ArgumentError("expected zero diagonal"))
    return HollowSymTridiagonal(A.ev)
end
function HollowSymTridiagonal{T}(A::SymTridiagonal) where {T}
    iszero(A.dv) || throw(ArgumentError("expected zero diagonal"))
    return HollowSymTridiagonal(AbstractVector{T}(A.ev))
end
Base.Matrix(A::HollowSymTridiagonal) = Matrix(SymTridiagonal(A))
Base.Matrix{T}(A::HollowSymTridiagonal) where {T} = Matrix{T}(SymTridiagonal{T}(A))

const AbstractSymTri{T} = Union{HollowSymTridiagonal{T}, SymTridiagonal{T}}

# for display purposes:
function Base.replace_in_print_matrix(A::HollowSymTridiagonal, i::Integer, j::Integer, s::AbstractString)
    i==j-1||i==j+1 ? s : Base.replace_with_centered_mark(s)
end
@inline function Base.getindex(A::HollowSymTridiagonal{T}, i::Integer, j::Integer) where T
    @boundscheck checkbounds(A, i, j)
    if i == j + 1
        return copy(transpose(@inbounds A.ev[j])) # materialized for type stability
    elseif i + 1 == j
        return @inbounds A.ev[i]
    else
        return zero(T)
    end
end

# Given a symmetric tridiagonal matrix H with H[i,i] = 0 and
# H[i-1,i] = H[i,i-1] = b[i-1], compute p(z) = det(z I - H) and its
# derivative p'(z), returning the ratio p / p'
function eigpolyrat(b::AbstractVector{<:Real},z::Number,m::Integer=length(b)+1)
    d1 = z
    d1deriv = d2 = one(z)
    d2deriv = zero(z)
    for i = 2:m
        b2 = b[i-1]^2
        d = z * d1 - b2 * d2
        dderiv = d1 + z * d1deriv - b2 * d2deriv
        if iszero(dderiv)
            d2, d1 = d1, d
            d2deriv, d1deriv = d1deriv, dderiv
        else # rescale to suppress under/overflow
            dderiv⁻¹ = inv(dderiv)
            d2, d1 = d1 * dderiv⁻¹, d * dderiv⁻¹
            d2deriv, d1deriv = d1deriv * dderiv⁻¹, one(dderiv)
        end
    end
    return d1 / d1deriv
end
eigpolyrat(H::HollowSymTridiagonal{<:Real},z) = eigpolyrat(H.ev, z)

# as above, but for general symmetric tridiagonal (diagonal ≠ 0)
function eigpolyrat(H::SymTridiagonal{<:Real},z::Number)
    d1 = z - H.dv[1]
    d1deriv = d2 = one(d1)
    d2deriv = zero(d1)
    for i = 2:length(H.dv)
        b2 = H.ev[i-1]^2
        a = z - H.dv[i]
        d = a * d1 - b2 * d2
        dderiv = d1 + a * d1deriv - b2 * d2deriv
        if iszero(dderiv)
            d2, d1 = d1, d
            d2deriv, d1deriv = d1deriv, dderiv
        else # rescale to suppress under/overflow
            dderiv⁻¹ = inv(dderiv)
            d2, d1 = d1 * dderiv⁻¹, d * dderiv⁻¹
            d2deriv, d1deriv = d1deriv * dderiv⁻¹, one(dderiv)
        end
    end
    return d1 / d1deriv
end

# compute the n smallest eigenvalues of the symmetric tridiagonal matrix H
# (defined from b as in eigpoly) using a Newton iteration
# on det(H - lambda I).  Unlike eig, handles BigFloat.
function eignewt(H::AbstractSymTri{T}, n::Integer) where {T<:Real}
    # get initial guess from eig on Float64 matrix
    lambda0 = eigvals(SymTridiagonal{Float64}(H), 1:n)
    lambda = Vector{float(T)}(lambda0)
    for i = 1:n
        for k = 1:1000
            δλ = eigpolyrat(H,lambda[i])
            if isfinite(δλ)
                lambda[i] -= δλ
                if abs(δλ) ≤ 10 * eps(lambda[i])
                    break
                end
            else
                break
            end
        end
    end
    return lambda
end
function eignewt(b::AbstractVector{<:Real},m::Integer,n::Integer)
    m == length(b)+1 || throw(ArgumentError("$m != length(b)+1 = $(length(b)+1) unsupported"))
    eignewt(HollowSymTridiagonal(b), n)
end

# given an eigenvalue λ and the matrix H(b) from above, return
# the corresponding eigenvector, normalized to 1.
function eigvec1!(v::AbstractVector, H::HollowSymTridiagonal, λ::Number)
    # "cheat" and use the fact that our eigenvector v must have a
    # nonzero first entries (since it is a quadrature weight), so we
    # can set v[1] = 1 to solve for the rest of the components:.
    m = size(H, 1)
    m == length(v) || throw(DimensionMismatch())
    v[1] = 1
    if m > 1
        s = v[1]
        v[2] = λ * v[1] / H.ev[1]
        s += abs2(v[2])
        for i = 3:m
            v[i] = (λ*v[i-1] - H.ev[i-2]*v[i-2]) / H.ev[i-1]
            s += abs2(v[i])
        end
        rmul!(v, 1 / sqrt(s))
    end
    return v
end
function eigvec1!(v::AbstractVector, b::AbstractVector, λ::Number, m=length(b)+1)
    m == length(b)+1 || throw(ArgumentError("$m != length(b)+1 = $(length(b)+1) unsupported"))
    return eigvec1!(v, HollowSymTridiagonal(b), λ)
end
eigvec1(b::AbstractVector, λ::Number, m=length(b)+1) =
    eigvec1!(Vector{promote_type(eltype(b),typeof(λ))}(undef, m), b, λ, m)

# as above but for a general SymTridiagonal
function eigvec1!(v::AbstractVector, H::SymTridiagonal, λ::Number)
    # "cheat" and use the fact that our eigenvector v must have a
    # nonzero first entries (since it is a quadrature weight), so we
    # can set v[1] = 1 to solve for the rest of the components:.
    m = size(H,1)
    m == length(v) || throw(DimensionMismatch())
    v[1] = 1
    if m > 1
        s = v[1]
        v[2] = (λ - H.dv[1]) * v[1] / H.ev[1]
        s += abs2(v[2])
        for i = 3:m
            v[i] = ((λ - H.dv[i-1])*v[i-1] - H.ev[i-2]*v[i-2]) / H.ev[i-1]
            s += abs2(v[i])
        end
        rmul!(v, 1 / sqrt(s))
    end
    return v
end

###########################################################################
# Gauss–Kronrod rules for the unit weight function:

"""
    gauss([T,] n)
    gauss([T,] n, a, b)

Return a pair `(x, w)` of `n` quadrature points `x[i]` and weights `w[i]` to
integrate functions on the interval ``(a, b)``, which defaults to ``(-1,1)``,  i.e. `sum(w .* f.(x))`
approximates the integral ``\\int_a^b f(x) dx``.

Uses the Golub–Welch method described in Trefethen &
Bau, Numerical Linear Algebra, to find the `n`-point Gaussian quadrature
rule in O(`n`²) operations.

`T` is an optional parameter specifying the floating-point type, defaulting
to `Float64`. Arbitrary precision (`BigFloat`) is also supported.  If `T` is not supplied,
 but the interval `(a, b)` is passed, then the floating-point type is determined
 from the types of `a` and `b`.
"""
function gauss(::Type{T}, N::Integer) where T<:AbstractFloat
    if N < 1
        throw(ArgumentError("Gauss rules require positive order"))
    end
    o = one(T)
    b = T[ n / sqrt(4n^2 - o) for n = 1:N-1 ]
    return gauss(HollowSymTridiagonal(b), 2)
end

gauss(N::Integer) = gauss(Float64, N) # integration on the standard interval (-1,1)

# re-scaled to an arbitrary interval:
gauss(N::Integer, a::Real, b::Real) = gauss(typeof(float(b-a)), N, a, b)
function gauss(::Type{T}, N::Integer, a::Real, b::Real) where T<:AbstractFloat
    x, w = gauss(T, N)
    s = T(b-a)/2
    x .= a .+ (x .+ 1) .* s
    w .*= abs(s)
    return (x, w)
end

function symtri(A::AbstractMatrix)
    J = SymTridiagonal(A) # may silently discard off-diagonal elements
    J == A || throw(ArgumentError("Jacobi matrix must be symmetric tridiagonal"))
    return J
end

# Gauss rules for an arbitrary Jacobi matrix J
"""
    gauss(J::AbstractMatrix, unitintegral::Real=1, [ (a₀,b₀) => (a,b) ])

Construct the ``n``-point Gaussian quadrature rule for ``I[f] = \\int_a^b w(x) f(x) dx``
from the ``n \\times n``
symmetric tridiagonal Jacobi matrix `J` corresponding to the orthogonal
polynomials for that weighted integral.  The value of `unitintegral` should
be ``I[1]``, the integral of the weight function.

An optional argument `(a₀,b₀) => (a,b)` allows you to specify that `J` was originally
defined for a different interval ``(a_0, b_0)``, which you want to rescale to
a given ``(a, b)``.  (`gauss` will rescale the points and weights for you.)

Returns a pair `(x, w)` of ``n`` quadrature points `x[i]` and weights `w[i]` to
integrate functions, i.e. `sum(w .* f.(x))` approximates the integral ``I[f]``.
"""
gauss(A::AbstractMatrix{<:Real}, unitintegral::Real=1) =
    gauss(symtri(A), unitintegral)

function gauss(J::AbstractSymTri{<:Real}, unitintegral::Real=1)
    N = size(J,1)
    # hollow eigenvalues come in ± pairs, so we only need to compute half
    n = J isa HollowSymTridiagonal ? (N+1) >> 1 : N

    # Golub–Welch algorithm
    x = eignewt(J, n)
    v = Vector{promote_type(eltype(J),eltype(x))}(undef, N)
    w = [ unitintegral * abs2(eigvec1!(v,J,x[i])[1]) for i = 1:n ]

    if n < N # fill in +x points from -x mirror images
        resize!(x, N)
        resize!(w, N)
        for i = n+1:N
            j = 2n+iseven(N)-i # mirror-image point in 1st half
            @inbounds x[i], w[i] = -x[j], w[j]
        end
    end

    return (x, w)
end

# as above but rescaled to an arbitrary interval and unit integral
function gauss(J::AbstractMatrix{<:Real}, unitintegral::Real, xrescale::Pair{<:Tuple{Real,Real}, <:Tuple{Real,Real}})
    x, w = gauss(J, unitintegral)
    T = eltype(x)
    a0, b0 = xrescale.first
    a, b = xrescale.second
    xscale = (T(b) - T(a)) / (T(b0) - T(a0))
    x .= (x .- a0) .* xscale .+ a
    return x, w
end

"""
    kronrod([T,] n)
    kronrod([T,] n, a, b)

Compute ``2n+1`` Kronrod points `x[i]` and weights `w[i]` based on the description in
Laurie (1997), appendix A, for integrating on the interval ``(a,b)`` (defaulting to ``[-1,1]``).

If `a` and `b` are not passed, since the rule is symmetric,
this only returns the `n+1` points with `x <= 0`.
The function Also computes the embedded `n`-point Gauss quadrature weights `wg`
(again for `x <= 0` if `a` and `b` are not passed), corresponding to the points `x[2:2:end]`.
Returns `(x,w,wg)` in O(`n`²) operations.

`T` is an optional parameter specifying the floating-point type, defaulting
to `Float64`. Arbitrary precision (`BigFloat`) is also supported.

Given these points and weights, the estimated integral `I` and error `E` can
be computed for an integrand `f(x)` as follows:

```julia
x, w, wg = kronrod(n)
fx⁰ = f(x[end])                # f(0)
x⁻ = x[1:end-1]                # the x < 0 Kronrod points
fx = f.(x⁻) .+ f.((-).(x⁻))    # f(x < 0) + f(x > 0)
I = sum(fx .* w[1:end-1]) + fx⁰ * w[end]
if isodd(n)
    E = abs(sum(fx[2:2:end] .* wg[1:end-1]) + fx⁰*wg[end] - I)
else
    E = abs(sum(fx[2:2:end] .* wg[1:end])- I)
end
```
"""
function kronrod(::Type{T}, n::Integer) where T<:AbstractFloat
    n < 1 && throw(ArgumentError("Kronrod rules require positive order"))

    o = one(T)
    b = zeros(T, 2n)
    for j = 1:div(3n+1,2)
        b[j] = j^2 / (4j^2 - o)
    end
    x, w, v = _kronrod(HollowSymTridiagonal(b), b, Int(n), 2)

    # Get embedded Gauss rule from even-indexed points, using
    # the Golub–Welch method as described in Trefethen and Bau.
    # (we don't need the eigenvalues since we already have them).
    for j = 1:n-1
        b[j] = j / sqrt(4j^2 - o)
    end
    @views wg = T[ 2abs2(eigvec1!(v[1:n],b[1:n-1],x[i],n)[1]) for i = 2:2:n+1 ]

    return x, w, wg
end

kronrod(n::Integer) = kronrod(Float64, n)

# as above but allow you to pass the interval [a,b],
# and returns all the points not just half
function kronrod(n::Integer, a::Real, b::Real)
    x, w, wg = kronrod(typeof(float(b-a)), n)
    x = [x; rmul!(reverse!(x[1:end-1]), -1)]
    w = [w; reverse!(w[1:end-1])]
    wg = [wg; reverse!(wg[1:end-isodd(n)])]
    T = eltype(x)
    xscale = (T(b) - T(a)) / 2
    x .= (x .+ 1) .* xscale .+ a
    w .*= xscale
    wg .*= xscale
    return x, w, wg
end

# as above, but generalized to an arbitrary Jacobi matrix
"""
    kronrod(J::AbstractMatrix, n::Integer, unitintegral::Real=1, [ (a₀,b₀) => (a,b) ])

Construct the ``2n+1``-point Gauss–Kronrod quadrature rule for ``I[f] = \\int_a^b w(x) f(x) dx``
from the ``m \\times m``
symmetric tridiagonal Jacobi matrix `J` corresponding to the orthogonal
polynomials for that weighted integral, where `m ≥ (3n+3)÷2`.  The value of `unitintegral` should
be ``I[1]``, the integral of the weight function.

An optional argument `(a₀,b₀) => (a,b)` allows you to specify that `J` was originally
defined for a different interval ``(a_0, b_0)``, which you want to rescale to
a given ``(a, b)``.  (`gauss` will rescale the points and weights for you.)

Returns a tuple `(x, w, wg)` of ``n`` quadrature points `x[i]` and weights `w[i]` to
integrate functions, i.e. `sum(w .* f.(x))` approximates the integral ``I[f]``.  `wg`
are the weights of the embedded Gauss rule corresponding to the points `x[2:2:end]`,
which can be used for error estimation.
"""
kronrod(A::AbstractMatrix{<:Real}, n::Integer, unitintegral::Real=1) =
    kronrod(symtri(A), n, unitintegral)

function kronrod(J::AbstractSymTri{<:Real}, n::Integer, unitintegral::Real=1)
    x, w, v = _kronrod(J, _kronrod_b(J, n), Int(n), unitintegral)

    # Get embedded Gauss rule from even-indexed points
    Jsmall = if J isa SymTridiagonal
        @views SymTridiagonal(J.dv[1:n], J.ev[1:n-1])
    else
        @views HollowSymTridiagonal(J.ev[1:n-1])
    end
    @views wg = [ unitintegral*abs2(eigvec1!(v[1:n],Jsmall,x[i])[1]) for i = 2:2:length(x) ]

    return x, w, wg
end

function kronrod(J::AbstractMatrix{<:Real}, n::Integer, unitintegral::Real, xrescale::Pair{<:Tuple{Real,Real}, <:Tuple{Real,Real}})
    x, w, wg = kronrod(J, n, unitintegral)
    if J isa HollowSymTridiagonal
        x = [x; rmul!(reverse!(x[1:end-1]), -1)]
        w = [w; reverse!(w[1:end-1])]
        wg = [wg; reverse!(wg[1:end-isodd(n)])]
    end
    a0, b0 = xrescale.first
    a, b = xrescale.second
    T = eltype(x)
    xscale = (T(b) - T(a)) / (T(b0) - T(a0))
    x .= (x .- a0) .* xscale .+ a
    return x, w, wg
end

"""
    kronrodjacobi(J::Union{SymTridiagonal, QuadGK.HollowSymTridiagonal}, n::Integer)

Given a real-symmetric tridiagonal matrix `J`, return the symmetric tridiagonal
"Kronrod–Jacobi" matrix, whose eigenvalues and eigenvectors yield the Gauss–Kronrod
rule of order `n`, e.g. by calling `x, w = gauss(kronrodjacobi(n))`.

See also the [`kronrod`](@ref) function, which returns the Kronrod points and
weights directly, along with the weights of an embedded Gauss rule.

``O(n^2)`` algorithm from Dirk P. Laurie, "Calculation of Gauss-Kronrod quadrature rules,"
*Mathematics of Computation*, vol. 66, no. 219, pp. 1133-1145 (1997).
"""
kronrodjacobi(J::AbstractSymTri{<:Real}, n::Integer) =
    _kronrodjacobi(J, _kronrod_b(J, n), Int(n))

###########################################################################
# internal implementation of algorithm from Laurie (1997) to return the (x,w)
# of the order-n Gauss–Kronrod rule, given the Jacobi matrix J of the weight,
# the order n, and a vector b of length 2n that has ALREADY been initialized
# to J.ev[j]^2 for j=1:div(3n+1,2) and to 0 otherwise.  J.ev is NOT used.

# construct the b vector from J, for passing to the other _kronrod functions below.
function _kronrod_b(J::AbstractSymTri{<:Real}, n::Integer)
    n < 1 && throw(ArgumentError("Kronrod rules require positive order"))
    size(J,1) ≥ div(3n+3,2) || throw(ArgumentError("J size must be ≥ $(div(3n+3,2)) for n=$n"))

    b = zeros(float(eltype(J)), 2n)
    for j = 1:div(3n+1,2)
        b[j] = J.ev[j]^2
    end
    return b
end

# Laurie's algorithm seems to suffer from spurious underflow,
# in which the s, t factors get exponentially smaller as n
# increases.  A workaround is to simply renormalize them on
# each step, which is allowed because our final answer only
# depends on their ratios.  There is probably a more elegant
# workaround, and we could be more clever about normalizing
# only where needed, but this only slows down kronrod by
# by a constant factor (about 1%), so not much payoff in being clever.
# (Laurie mentions this problem in passing: they work around it
#  by rescaling the interval by 2, which rescales b by 4 and hence
#  causes b to asymptote to 1.0 rather than 0.25, suppressing the
#  exponential underflow.  It's not clear how to generalize that
#  hack to arbitrary Jacobi matrices, however.)  See issue #93.
function normalize2!(s, t, maxabs, n)
    if !iszero(maxabs)
        scaleby = inv(maxabs)
        for i = 1:n
            s[i] *= scaleby
            t[i] *= scaleby
        end
    end
    return s, t
end

# return the Kronrod–Jacobi matrix
function _kronrodjacobi(J::AbstractSymTri{<:Real}, b::AbstractVector{T}, n::Int) where {T<:AbstractFloat}
    # these are checked above:
    # size(J,1) > div(3n+1,2) || throw(ArgumentError("J size must be > $(div(3n+1,2)) for n=$n"))
    # length(b) == 2n || throw(DimensionMismatch())

    # construct a,b of Jacobi–Kronrod matrix:
    if J isa SymTridiagonal
        a = copyto!(zeros(T, 2n+1), 1, J.dv, 1, div(3n, 2) + 1)
        # (a is zero if J isa HollowSymTridiagonal, and is hence omitted).
    end
    s = zeros(T, div(n,2) + 2)
    t = zeros(T, length(s))
    t[2] = b[n+1]
    for m = 0:n-2
        maxabs = u = zero(T)
        for k = div(m+1,2):-1:0
            u += b[k + n + 1]*s[k+1] - (m > k ? b[m - k]*s[k+2] : zero(T))
            if J isa SymTridiagonal
                u += (a[k+n+2] - a[(m-k)+1]) * t[k+2]
            end
            s[k+2] = u
            maxabs = max(maxabs, abs(u))
        end
        t, s = normalize2!(s, t, maxabs, div(m+1,2)+2) # normalize & swap
    end
    for j = div(n,2):-1:0
        s[j+2] = s[j+1]
    end
    for m = n-1:2n-3
        maxabs = u = zero(T)
        for k = m+1-n:div(m-1,2)
            j = n - (m - k) - 1
            u -= b[k + n + 1]*s[j+2] - b[m - k]*s[j+3]
            if J isa SymTridiagonal
                u -= (a[k+n+2] - a[(m-k)+1]) * t[j+2]
            end
            s[j+2] = u
            maxabs = max(maxabs, abs(u))
        end
        t, s = normalize2!(s, t, maxabs, length(s)) # normalize & swap
        k = div(m+1,2)
        j = n - (m - k + 2)
        if 2k != m
            b[k+n+1] = t[j+2] / t[j+3]
        elseif J isa SymTridiagonal
            a[k+n+2] = a[k+1] + (t[j+2] - b[k+n+1] * t[j+3]) / s[j+3]
        end
    end
    if J isa SymTridiagonal
        a[2n+1] = a[n] - b[2n]*s[2]/t[2]
    end

    # Note: this sqrt.(b) step can fail if any element of b is negative.
    # This can happen because Gauss–Kronrod points and weights are not guaranteed
    # to be real for all orthogonal polynomials (all Jacobi matrices J)!
    # We won't try to handle this case in QuadGK for now.
    any(<(0), b) && throw(ArgumentError("real Gauss–Kronrod rule does not exist for this Jacobi matrix"))
    b .= sqrt.(b)

    # the Jacobi–Kronrod matrix:
    return J isa SymTridiagonal ? SymTridiagonal(a, b) : HollowSymTridiagonal(b)
end

# return the Kronrod weights and rule.  unitintegral should be the integral of the weight function
function _kronrod(J::AbstractSymTri{<:Real}, b::AbstractVector{T}, n::Int, unitintegral::Real=1) where {T<:AbstractFloat}
    # the Jacobi–Kronrod matrix:
    KJ = _kronrodjacobi(J, b, n)

    # now we just apply Golub–Welch to KJ:

    # get quadrature points x (negative points only for HollowSymTridiagonal)
    x = eignewt(KJ, J isa SymTridiagonal ? 2n+1 : n+1)

    v = Vector{promote_type(eltype(b),eltype(x))}(undef, 2n+1)

    # get quadrature weights
    w = T[ unitintegral * abs2(eigvec1!(v,KJ,λ)[1]) for λ in x ]

    return (x, w, v)
end

###########################################################################
# Type-stable cache of quadrature rule results, so that we don't
# repeat the kronrod calculation unnecessarily.

# precomputed n=7 rule in double precision (computed in 100-bit arithmetic),
# since this is the common case.
const xd7 = [-9.9145537112081263920685469752598e-01,
             -9.4910791234275852452618968404809e-01,
             -8.6486442335976907278971278864098e-01,
             -7.415311855993944398638647732811e-01,
             -5.8608723546769113029414483825842e-01,
             -4.0584515137739716690660641207707e-01,
             -2.0778495500789846760068940377309e-01,
             0.0]
const wd7 = [2.2935322010529224963732008059913e-02,
             6.3092092629978553290700663189093e-02,
             1.0479001032225018383987632254189e-01,
             1.4065325971552591874518959051021e-01,
             1.6900472663926790282658342659795e-01,
             1.9035057806478540991325640242055e-01,
             2.0443294007529889241416199923466e-01,
             2.0948214108472782801299917489173e-01]
const wgd7 = [1.2948496616886969327061143267787e-01,
              2.797053914892766679014677714229e-01,
              3.8183005050511894495036977548818e-01,
              4.1795918367346938775510204081658e-01]

# cache of T -> n -> (x,w,wg) Kronrod rules, to avoid recomputing them
# unnecessarily for repeated integration.   We initialize it with the
# default n=7 rule for double-precision calculations.  We use a cache
# of caches to allow us to evaluate the cache in a type-stable way with
# a generated function below.
const rulecache = Dict{Type,Dict}(
    Float64 => Dict{Int,NTuple{3,Vector{Float64}}}(7 => (xd7,wd7,wgd7)),
    Float32 => Dict{Int,NTuple{3,Vector{Float32}}}(7 => (xd7,wd7,wgd7)))
const rulecache_lock = ReentrantLock() # thread-safety

# for BigFloat rules, we need a separate cache keyed by (n,precision)
const bigrulecache = Dict{Tuple{Int,Int}, NTuple{3,Vector{BigFloat}}}()
const bigrulecache_lock = ReentrantLock() # thread-safety

function cachedrule(::Union{Type{BigFloat},Type{Complex{BigFloat}}}, n::Integer)
    key = (Int(n), precision(BigFloat))
    lock(bigrulecache_lock)
    try
        return haskey(bigrulecache, key) ? bigrulecache[key] : (bigrulecache[key] = kronrod(BigFloat, Int(n)))
    finally
        unlock(bigrulecache_lock)
    end
end

# use a generated function to make this type-stable
@generated function _cachedrule(::Type{TF}, n::Int) where {TF}
    cache = haskey(rulecache, TF) ? rulecache[TF] : (rulecache[TF] = Dict{Int,NTuple{3,Vector{TF}}}())
    :(haskey($cache, n) ? $cache[n] : ($cache[n] = kronrod($TF, n)))
end

function cachedrule(::Type{T}, n::Integer) where {T<:Number}
    lock(rulecache_lock)
    try
        return _cachedrule(typeof(float(real(one(T)))), Int(n))
    finally
        unlock(rulecache_lock)
    end
end

# fast path for common case of Float64 precision and default order
function cachedrule(::Union{Type{Float64},Type{ComplexF64}}, n::Integer)
    n == 7 && return (xd7,wd7,wgd7)
    lock(rulecache_lock)
    try
        return _cachedrule(Float64, Int(n))
    finally
        unlock(rulecache_lock)
    end
end

# the high-level quadgk* API functions and friends

"""
    quadgk(f, a,b,c...; rtol=sqrt(eps), atol=0, maxevals=10^7, order=7, norm=norm, segbuf=nothing, eval_segbuf=nothing)

Numerically integrate the function `f(x)` from `a` to `b`, and optionally over additional
intervals `b` to `c` and so on. Keyword options include a relative error tolerance `rtol`
(if `atol==0`, defaults to `sqrt(eps)` in the precision of the endpoints), an absolute error tolerance
`atol` (defaults to 0), a maximum number of function evaluations `maxevals` (defaults to
`10^7`), and the `order` of the integration rule (defaults to 7).
Returns a pair `(I,E)` of the estimated integral `I` and an estimated upper bound on the
absolute error `E`. If `maxevals` is not exceeded then `E <= max(atol, rtol*norm(I))`
will hold. (Note that it is useful to specify a positive `atol` in cases where `norm(I)`
may be zero.)

The endpoints `a` et cetera can also be complex (in which case the integral is performed over
straight-line segments in the complex plane). If the endpoints are `BigFloat`, then the
integration will be performed in `BigFloat` precision as well.

!!! note
    It is advisable to increase the integration `order` in rough proportion to the
    precision, for smooth integrands.

More generally, the precision is set by the precision of the integration
endpoints (promoted to floating-point types).

Instead of passing the integration domain as separate arguments `a,b,c...`,
you can alternatively pass the domain as a single argument: an array of
endpoints `[a,b,c...]` or an array of interval tuples `[(a,b), (b,c)]`.
(The latter enables you to integrate over a disjoint domain if you want.)

The integrand `f(x)` can return any numeric scalar, vector, or matrix type, or in fact any
type supporting `+`, `-`, multiplication by real values, and a `norm` (i.e., any normed
vector space). Alternatively, a different norm can be specified by passing a `norm`-like
function as the `norm` keyword argument (which defaults to `norm`).

!!! note
    Only one-dimensional integrals are provided by this function. For multi-dimensional
    integration (cubature), there are many different algorithms (often much better than simple
    nested 1d integrals) and the optimal choice tends to be very problem-dependent. See the
    Julia external-package listing for available algorithms for multidimensional integration or
    other specialized tasks (such as integrals of highly oscillatory or singular functions).

The algorithm is an adaptive Gauss-Kronrod integration technique: the integral in each
interval is estimated using a Kronrod rule (`2*order+1` points) and the error is estimated
using an embedded Gauss rule (`order` points). The interval with the largest error is then
subdivided into two intervals and the process is repeated until the desired error tolerance
is achieved.

These quadrature rules work best for smooth functions within each interval, so if your
function has a known discontinuity or other singularity, it is best to subdivide your
interval to put the singularity at an endpoint. For example, if `f` has a discontinuity at
`x=0.7` and you want to integrate from 0 to 1, you should use `quadgk(f, 0,0.7,1)` to
subdivide the interval at the point of discontinuity. The integrand is never evaluated
exactly at the endpoints of the intervals, so it is possible to integrate functions that
diverge at the endpoints as long as the singularity is integrable (for example, a `log(x)`
or `1/sqrt(x)` singularity).

For real-valued endpoints, the starting and/or ending points may be infinite. (A coordinate
transformation is performed internally to map the infinite interval to a finite one.)

In normal usage, `quadgk(...)` will allocate a buffer for segments. You can
instead pass a preallocated buffer allocated using `alloc_segbuf(...)` as the
`segbuf` argument.  Alternatively, one can replace the first `quadgk(...)`
call with `quadgk_segbuf(...)` to return the segment buffer from a given
call.  This buffer can be used across multiple calls to avoid
repeated allocation.   Upon return from `quadgk`, the `segbuf` array contains
an array of subintervals that were used for the final quadrature evaluation.

By passing `eval_segbuf=segbuf` to a subsequent call to `quadgk`, these subintervals
can be re-used as the starting point for the next integrand evaluation (over the
same domain), even for an integrand of a different result type; by also passing
`maxevals=0`, further refinement of these subintervals is prohibited, so that it
forces the same quadrature rule to be used (which is useful for evaluating e.g.
derivatives of the approximate integral).
"""
quadgk(f, segs...; kws...) =
    quadgk(f, promote(segs...)...; kws...)

function quadgk(f, segs::T...;
       atol=nothing, rtol=nothing, maxevals=10^7, order=7, norm=norm, segbuf=nothing, eval_segbuf=nothing) where {T}
    handle_infinities(f, segs) do f, s, _
        do_quadgk(f, s, order, atol, rtol, maxevals, norm, segbuf, eval_segbuf)
    end
end

"""
    function alloc_segbuf(domain_type=Float64, range_type=Float64, error_type=Float64; size=1)

This helper will allocate a segment buffer for segments to a `quadgk(...)` call
with the given `domain_type`, which is the same as the type of the integration
limits, `range_type` i.e. the range of the function being integrated and
`error_type`, the type returned by the `norm` given to `quadgk(...)` and
starting with the given `size`. The buffer can then be reused across multiple
compatible calls to `quadgk(...)` to avoid repeated allocation.

Alternatively, you can replace your first call to `quadgk(...)` with a
call to `quadgk_segbuf(...)`, which returns the computed segment buffer
from your first integration.  This saves you the trouble of figuring out
`domain_type` etc., which may not be obvious if the integrand is a variable.
"""
function alloc_segbuf(domain_type=Float64, range_type=Float64, error_type=Float64; size=1)
    Vector{Segment{domain_type, range_type, error_type}}(undef, size)
end

"""
    quadgk!(f!, result, a,b,c...; rtol=sqrt(eps), atol=0, maxevals=10^7, order=7, norm=norm)

Like `quadgk`, but make use of in-place operations for array-valued integrands (or other mutable
types supporting in-place operations).  In particular, there are two differences from `quadgk`:

1. The function `f!` should be of the form `f!(y, x) = y .= f(x)`.  That is, it writes the
   return value of the integand `f(x)` in-place into its first argument `y`.   (The return
   value of `f!` is ignored.)

2. Like `quadgk`, the return value is a tuple `(I,E)` of the estimated integral `I` and the
   estimated error `E`.   However, in `quadgk!` the estimated integral is written in-place
   into the `result` argument, so that `I === result`.

Otherwise, the behavior is identical to `quadgk`.

For integrands whose values are *small* arrays whose length is known at compile-time,
it is usually more efficient to use `quadgk` and modify your integrand to return
an `SVector` from the [StaticArrays.jl package](https://github.com/JuliaArrays/StaticArrays.jl).
"""
quadgk!(f!, result, segs...; kws...) =
    quadgk!(f!, result, promote(segs...)...; kws...)

function quadgk!(f!, result, a::T,b::T,c::T...; atol=nothing, rtol=nothing, maxevals=10^7, order=7, norm=norm, segbuf=nothing, eval_segbuf=nothing) where {T}
    fx = result / oneunit(T) # pre-allocate array of correct type for integrand evaluations
    f = InplaceIntegrand(f!, result, fx)
    return quadgk(f, a, b, c...; atol=atol, rtol=rtol, maxevals=maxevals, order=order, norm=norm, segbuf=segbuf, eval_segbuf=eval_segbuf)
end

struct Counter{F}
    f::F
    count::Base.RefValue{Int}
end
function (c::Counter{F})(args...) where F
    c.count[] += 1
    c.f(args...)
end

"""
    quadgk_count(f, args...; kws...)

Identical to [`quadgk`](@ref) but returns a triple `(I, E, count)`
of the estimated integral `I`, the estimated error bound `E`, and a `count`
of the number of times the integrand `f` was evaluated.

The count of integrand evaluations is a useful performance metric: a large
number typically indicates a badly behaved integrand (with singularities,
discontinuities, sharp peaks, and/or rapid oscillations), in which case
it may be possible to mathematically transform the problem in some way
to improve the convergence rate.
"""
function quadgk_count(f, args...; kws...)
    counter = Counter(f, Ref(0))
    i = quadgk(counter, args...; kws...)
    return (i..., counter.count[])
end

"""
    quadgk_print([io], f, args...; kws...)

Identical to [`quadgk`](@ref), but **prints** each integrand
evaluation to the stream `io` (defaults to `stdout`) in the form:
```
f(x1) = y1
f(x2) = y2
...
```
which is useful for pedagogy and debugging.

Also, like [`quadgk_count`](@ref), it returns a triple `(I, E, count)`
of the estimated integral `I`, the estimated error bound `E`, and a `count`
of the number of times the integrand `f` was evaluated.
"""
quadgk_print(io::IO, f, args...; kws...) = quadgk_count(args...; kws...) do x
    y = f(x)
    println(io, "f(", x, ") = ", y)
    y
end
quadgk_print(f, args...; kws...) = quadgk_print(stdout, f, args...; kws...)

# variants that also return a segment buffer:

"""
    quadgk_segbuf(args...; kws...)

Identical to `quadgk(args...; kws...)`, but returns a tuple
`(I, E, segbuf)` where `segbuf` is a segment buffer (storing the
subintervals used for the final integral evaluation) that can
be passed as a `segbuf` and/or `eval_segbuf` argument on subsequent
calls to `quadgk` and related functions.
"""
quadgk_segbuf(args...; segbuf=nothing, kws...) =
    quadgk(args...; segbuf=ReturnSegbuf(segbuf), kws...)


"""
    quadgk_segbuf_count(args...; kws...)

Identical to `quadgk_count(args...; kws...)`, but returns a tuple
`(I, E, segbuf, count)` where `segbuf` is a segment buffer (storing the
subintervals used for the final integral evaluation) that can
be passed as a `segbuf` and/or `eval_segbuf` argument on subsequent
calls to `quadgk` and related functions.
"""
quadgk_segbuf_count(args...; segbuf=nothing, kws...) =
    quadgk_count(args...; segbuf=ReturnSegbuf(segbuf), kws...)

"""
    quadgk_segbuf_print(args...; kws...)

Identical to `quadgk_print(args...; kws...)`, but returns a tuple
`(I, E, segbuf, count)` where `segbuf` is a segment buffer (storing the
subintervals used for the final integral evaluation) that can
be passed as a `segbuf` and/or `eval_segbuf` argument on subsequent
calls to `quadgk` and related functions.
"""
quadgk_segbuf_print(args...; segbuf=nothing, kws...) =
    quadgk_print(args...; segbuf=ReturnSegbuf(segbuf), kws...)

"""
    quadgk_segbuf!(args...; kws...)

Identical to `quadgk!(args...; kws...)`, but returns a tuple
`(I, E, segbuf)` where `segbuf` is a segment buffer (storing the
subintervals used for the final integral evaluation) that can
be passed as a `segbuf` and/or `eval_segbuf` argument on subsequent
calls to `quadgk` and related functions.
"""
quadgk_segbuf!(args...; segbuf=nothing, kws...) =
    quadgk!(args...; segbuf=ReturnSegbuf(segbuf), kws...)

# variants that take an array of points or an array of (a,b) tuples
# to specify the integration domain:

function quadgk(f, segs::Union{AbstractVector{<:Number},AbstractVector{<:Tuple{Number,Number}}}; kws...)
    segbuf, min, max = to_segbuf(segs)
    return quadgk(f, min, max; eval_segbuf=segbuf, kws...)
end
function quadgk!(f, result, segs::Union{AbstractVector{<:Number},AbstractVector{<:Tuple{Number,Number}}}; kws...)
    segbuf, min, max = to_segbuf(segs)
    return quadgk!(f, result, min, max; eval_segbuf=segbuf, kws...)
end

# helper function for above: convert array of points or intervals
# to array of Segment, along with min/max of all points so that
# quadgk gets the correct domain type and handles infinities
function to_segbuf(x::AbstractVector{<:Number})
    length(x) >= 2 || throw(ArgumentError("at least 2 endpoints are required"))
    Tx = float(isconcretetype(eltype(x)) ? eltype(x) : mapreduce(typeof, promote_type, x))
    segbuf = Segment{Tx,Nothing,Nothing}[Segment(Tx(x[i]), Tx(x[i+1])) for i in firstindex(x):lastindex(x)-1]
    return segbuf, Tx.(extrema(real, x))...
end
function to_segbuf(segments::AbstractVector{<:Tuple{Number,Number}})
    !isempty(segments) || throw(ArgumentError("at least 1 interval is required"))
    Tx = float(if isconcretetype(eltype(segments))
        promote_type(fieldtypes(eltype(segments))...)
    else
        mapreduce(seg -> promote_type(typeof.(seg)...), promote_type, segments)
    end)
    return Segment{Tx,Nothing,Nothing}[Segment(Tx(seg[1]), Tx(seg[2])) for seg in segments],
           Tx(minimum(seg -> min(real.(seg)...), segments)),
           Tx(maximum(seg -> max(real.(seg)...), segments))
end

using Documenter, QuadGK

makedocs(
    modules = [QuadGK],
    clean = false,
    sitename = "QuadGK.jl",
    authors = "Steven G. Johnson and contributors.",
    pages = [
        "Home" => "index.md",
        "Examples" => "quadgk-examples.md",
        "Quadrature rules" => "gauss-kronrod.md",
        "Weighted quadrature" => "weighted-gauss.md",
        "API reference" => "api.md",
    ],
    warnonly = [:missing_docs],
)

deploydocs(
    repo = "github.com/JuliaMath/QuadGK.jl.git",
    target = "build",
    deps = nothing,
    make = nothing,
)

# QuadGK.jl

This package implements one-dimensional numerical integration
("quadrature") in Julia using adaptive [Gauss–Kronrod quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Kronrod_quadrature_formula).

That is, it computes integrals $\int_a^b f(x) dx$ numerically,
given the endpoints $(a,b)$ and an arbitrary function $f$, to
any desired accuracy, using the function [`quadgk`](@ref).

(The code was originally [part of Base Julia](https://github.com/JuliaLang/julia/pull/3140).)

## Features

Features of the QuadGK package include:

* h-adaptive integration: automatically subdivides the integration integral into smaller segments until a desired accuracy is reached, allowing it to evaluate the integrand more densely in regions where it is badly behaved (e.g. oscillating rapidly).
* arbitrary integrand types: the integrand `f(x)` can return real numbers, complex numbers, vectors, matrices, or any Julia type supporting `±`, multiplication by scalars, and `norm` (i.e. implementing any [Banach space](https://en.wikipedia.org/wiki/Banach_space)).
* Arbitrary precision: arbitrary-precision arithmetic types such as `BigFloat` can be integrated to arbitrary accuracy
* ["Improper" integrals](https://en.wikipedia.org/wiki/Improper_integral): Integral endpoints can be $\pm \infty$ (`±Inf` in Julia).
* [Contour integrals](https://en.wikipedia.org/wiki/Contour_integration): You can specify a sequence of points in the complex plane to perform a contour integral along a piecewise-linear contour.
* Arbitrary-order and custom quadrature rules: Any polynomial `order` of the Gauss–Kronrod quadrature rule can be specified, as well as generating quadrature rules and weights directly; see [Gauss and Gauss–Kronrod quadrature rules](@ref).  Custom Gaussian-quadrature rules can also be constructed for arbitrary weight functions; see [Gaussian quadrature and arbitrary weight functions](@ref).
* In-place integration: For memory efficiency, integrand functions that write in-place into a pre-allocated buffer (e.g. for vector-valued integrands) can be used with the [`quadgk!`](@ref) function, along with pre-allocated buffers using [`alloc_segbuf`](@ref).
* Batched integrand evaluation: Providing an integrand that can evaluate multiple points simultaneously allows for user-controlled parallelization (e.g. using threads, the GPU, or distributed memory).

## Quick start

The following code computes $\int_0^1 \cos(200x) dx$ numerically, to the default accuracy (a [relative error](https://en.wikipedia.org/wiki/Approximation_error) $\lesssim 10^{-8}$), using [`quadgk`](@ref):
```julia-repl
julia> using QuadGK

julia> integral, error = quadgk(x -> cos(200x), 0, 1)
(-0.004366486486069925, 2.552917865170437e-13)
```
Notice that the result is a [tuple](https://docs.julialang.org/en/v1/manual/functions/#Tuples) of two values: the estimated `integral`
of `-0.004366486486069925`, an estimated upper bound `error ≈ 2.55e-13`
on the [truncation error](https://en.wikipedia.org/wiki/Truncation_error) in the computed integral (due to the finite number of points at which `quadgk` evaluates the integrand).

By default, `quadgk` evaluates the integrand at more and more points ("adaptive quadrature") until
the relative error estimate is less than `sqrt(eps())`, corresponding to about 8 significant digits.  Often, however, you should change this by passing a relative tolerance (`rtol`) and/or an absolute tolerance (`atol`), e.g.:
```julia-repl
julia> quadgk(x -> cos(200x), 0, 1, rtol=1e-3)
(-0.004366486486069085, 2.569238200052031e-6)
```

For extremely [smooth functions](https://en.wikipedia.org/wiki/Smoothness) like $\cos(200x)$, even though it is highly oscillatory, `quadgk` often gives a very accurate result, even more accurate than the minimum accuracy you requested (defaulting to about 8 digits).  In this particular case, we know that the exact integral is $\sin(200)/200 \approx -0.004366486486069972908665092105754\ldots$, and `integral` matches this to about 14 [significant digits](https://en.wikipedia.org/wiki/Significant_figures) with the default tolerance and to about 13 digits even for `rtol=1e-3`.

## Tutorial examples

The [`quadgk` examples](@ref) chapter of this manual presents several other examples, including improper integrals, vector-valued integrands, batched integrand evaluation, improper integrals, singular or near-singular integrands, and Cauchy principal values.

## In-place operations for array-valued integrands

For integrands whose values are *small* arrays whose length is known at compile-time,
it is usually most efficient to modify your integrand to return
an `SVector` from the [StaticArrays.jl package](https://github.com/JuliaArrays/StaticArrays.jl).

However, for integrands that return large or runtime-length arrays, we also provide a function
`quadgk!(f!, result, a,b...)` in order to exploit in-place operations where possible.   The
`result` argument is used to store the estimated integral `I` in-place, and the integrand function
is now of the form `f!(r, x)` and should write `f(x)` in-place into the result array `r`.  See the [`quadgk!`](@ref) documentation for more detail.

## API Reference

See the [API reference](@ref) chapter for a detailed description of the
QuadGK programming interface.

## Other Julia quadrature packages

The [FastGaussQuadrature.jl](https://github.com/ajt60gaibb/FastGaussQuadrature.jl) package provides
non-adaptive Gaussian quadrature variety of built-in weight functions — it is a
good choice you need to go to very high orders $N$, e.g. to integrate rapidly
oscillating functions, or use weight functions that incorporate some standard
singularity in your integrand.  QuadGK, on the other hand, keeps the order $N$
of the quadrature rule fixed and improves accuracy by subdividing the
integration domain, which can be better if fine resolution is required only in a
part of your domain (e.g if your integrand has a sharp peak or singularity
somewhere that is not known in advance).

Another quadrature algorithm that can be especially effective for integrands over infinite
domains or for integrands with unknown (but integrable) singularities at the domain boundaries
is [tanh–sinh quadrature](https://en.wikipedia.org/wiki/Tanh-sinh_quadrature), which is implemented in Julia by the [DoubleExponentialFormulas.jl](https://github.com/machakann/ DoubleExponentialFormulas.jl) package.

For multidimensional integration, see also the [HCubature.jl](https://github.com/stevengj/HCubature.jl), [Cubature.jl](https://github.com/stevengj/Cubature.jl), and
[Cuba.jl](https://github.com/giordano/Cuba.jl) packages, or alternatively [IteratedIntegration.jl](https://github.com/lxvm/IteratedIntegration.jl) for efficient nested 1d integrals (probably more efficient than nesting QuadGK directly).

Note that all of the above quadrature routines assume that you supply your integrand
as a *function* $f(x)$ that can be evaluated at *arbitrary points* inside the
integration domain.  This is ideal, because then the integration algorithm can
choose points so that the accuracy improves rapidly (often exponentially rapidly)
with the number of points.   However if you only have function values supplied
at pre-determined points, such as on a regular grid, then you should use
another (probably slower-converging) algorithm in a package such as
[Trapz.jl](https://github.com/francescoalemanno/Trapz.jl), [Romberg.jl](https://github.com/fgasdia/Romberg.jl), [NumericalIntegration.jl](https://github.com/dextorious/NumericalIntegration.jl), [ConvolutionInterpolations.jl](https://github.com/NikoBiele/ConvolutionInterpolations.jl), or [FastInterpolations.jl](https://github.com/ProjectTorreyPines/FastInterpolations.jl).

# `quadgk` examples

The following are several examples illustrating the usage of the main [`quadgk`](@ref) numerical-integration function of QuadGK, focusing on more complicated circumstances than the smooth scalar integral of the [Quick start](@ref) section.

## Improper integrals: Infinite limits

`quadgk` supports "improper" integrals over infinite and semi-infinite intervals,
simply by passing `±Inf` for the endpoints.

For example, $\int_0^\infty e^{-x} dx = 1$ is computed by:
```julia-repl
julia> quadgk(x -> exp(-x), 0, Inf)
(1.0, 4.507383379289404e-11)
```
which give gives the correct answer (1) exactly in this case.  Note that
the error estimate `≈ 4.5e-11` is pessimistic, as is often the case.

The [Gaussian integral](https://en.wikipedia.org/wiki/Gaussian_integral)
$\int_{-\infty}^{+\infty} e^{-x^2} dx = \sqrt{\pi} = 1.772453850905516027298167483341\ldots$ is computed by:
```julia-repl
julia> quadgk(x -> exp(-x^2), -Inf, Inf)
(1.7724538509055137, 6.4296367126505234e-9)
```
which is the correct answer to nearly [machine precision](https://en.wikipedia.org/wiki/Machine_epsilon), despite the pessimistic error estimate `≈ 6.4e-9`.

Internally, `quadgk` handles infinite limits by the [changes of variables](https://en.wikipedia.org/wiki/Integration_by_substitution)
```math
\int_a^\infty f(x)dx = \int_0^1 f{\left(a + \frac{t}{1-t}\right)} \frac{1}{(1-t)^2} dt
```
and
```math
\int_{-\infty}^\infty f(x)dx = \int_{-1}^1 f{\left(\frac{t}{1-t^2}\right)} \frac{1+t^2}{(1-t^2)^2} dt
```
respectively.   Although the transformed integrands are singular at the endpoints
$t = 1$ and $t = \pm 1$, respectively, because the singularities are integrable
and `quadgk` *never evaluates the integrand exactly at the endpoints*, it is able
to perform the numerical integration successfully.

Important tip: This change-of-variables trick works best if your function decays with $|x|$ over a lengthscale of order $\sim 1$.
If your decay length is much larger or shorter than that, it will perform poorly.  For example, with $f(x) = e^{-x/10^6}$ the
decay is over a lengthscale $\sim 10^6$ and `quadgk` requires many more evaluations (705) than for $e^{-x}$ (135, as measured by [`quadgk_count`](@ref),
described below):
```julia-repl
julia> quadgk_count(x -> exp(-x), 0, Inf)
(1.0, 4.507382674563286e-11, 135)

julia> quadgk_count(x -> exp(-x/1e6), 0, Inf)
(1.000000000001407e6, 0.0014578728207218505, 705)
```
If your function decays over a lengthscale $\sim L$, it is a good idea to compute improper integrals using a change of variables
$\int_a^b f(x)dx = \int_{a/L}^{b/L} f(uL) L \, du$, for example:
```julia-repl
julia> L = 1e6 # decay lengthscale
1.0e6

julia> f(x) = exp(-x/L)
f (generic function with 1 method)

julia> quadgk_count(u -> f(u*L) * L, 0, Inf) # rescaled integration over u = x/L
(1.0e6, 4.507388807828416e-5, 135)
```

## Counting and printing integrand evaluations

Often, it is a good idea to count the number of times the integrand is evaluated,
in order to have a sense of how efficiently `quadgk` is performing the integral;
this is especially useful with badly behaved integrand (e.g. with singularities,
discontinuities, sharp spikes, and/or rapid oscillations) to see whether some
transformation of the problem might be helpful (see below).

This is easy enough by simply incrementing a global counter in your integrand
function and printing progress as desired.    But it is such a common desire
in pedagogy and debugging that we provide convenience functions [`quadgk_count`](@ref)
and [`quadgk_print`](@ref) to automate this task.

For example, in our $\int_0^\infty e^{-x} dx$ example from above, we could do:
```julia-repl
julia> quadgk_count(x -> exp(-x), 0, Inf)
(1.0, 4.507383379289404e-11, 135)
```
to return the number of function evaluations (`135`) along with the integral (`1.0`)
and error estimate (`≈ 4.5e-11`).   A relatively large number of function evaluations
are required, even though the function $e^{-x}$ is very smooth, because the infinite
endpoint implicitly introduces a singularity (via the change of variables discussed
above).

We can also print the evaluation points, setting a lower requested relative accuracy of `rtol=1e-2` so that we don't get so much output, by:
```julia-repl
julia> quadgk_print(x -> exp(-x), 0, Inf, rtol=1e-2)
f(1.0) = 0.36787944117144233
f(0.655923922306948) = 0.5189623601162878
f(1.52456705113438) = 0.21771529605384055
f(0.026110451522445993) = 0.9742274787577301
f(38.29883980138536) = 2.3282264081806294e-17
f(0.00429064542600238) = 0.9957185462423211
f(233.06516868994527) = 6.04064500678147e-102
f(0.14841469193194298) = 0.8620735458624529
f(6.737877409458626) = 0.0011851600983136456
f(0.07246402202084404) = 0.9300992091482783
f(13.799951646519888) = 1.015680581505947e-6
f(0.42263178703605514) = 0.6553198859704107
f(2.3661258586654506) = 0.09384358625528809
f(0.26096469051417465) = 0.7703081183184751
f(3.831936029467112) = 0.021667625834125973
(0.9999887201849575, 0.0009180738585039538, 15)
```
to see that (for a relatively low requested relative accuracy of `rtol=1e-2`) it
evaluates the integrand only 15 times at points from $x \approx 0.00429$ to $x \approx 233.1$, and still managed to get about 5 significant digits correct.  (Note that
`quadgk_print` again returns a 3-element tuple, like `quadgk_count`, where the
third element is the number of integrand evaluations.)

## Integrands with singularities and discontinuities

The integral ``\int_0^1 x^{-1/2} dx = \left. 2 \sqrt{x} \right|_0^1 = 2`` is
perfectly finite even though the integrand $1/\sqrt{x}$ blows up at $x=0$.
This is an example of an *integrable singularity*, and `quadgk` can compute
this integral:
```julia-repl
julia> quadgk_count(x -> 1/sqrt(x), 0, 1)
(1.9999999845983916, 2.3762511924588765e-8, 1305)
```
Notice the large number (`1305`) of integrand evaluations returned by
[`quadgk_count`](@ref): this is an indication of how much more work it
is to evaluate an integral with a singularity or any other form of non-smoothness.
At its heart, the Gauss–Kronrod algorithm employed by `quadgk` works by
interpolating the integrand with polynomials over segments of the domain,
and polynomials are bad at representing [non-analytic functions](https://en.wikipedia.org/wiki/Analytic_function) like $1/\sqrt{x}$.

The good news is that `quadgk` **never evaluates functions exactly at the endpoints**,
so it is okay if your function blows up or errors at those points.   (However, you may have
to relax your error tolerance because of the slow convergence, and floating-point limitations
may prevent `quadgk` from reaching very low error tolerances for singular integrands.)   Of
course, it is always better to remove the singularity by some analytical transformation if you
can.  For example, if you need $\int_0^a f(x) x^{-1/2} dx$, you can do a change of variables $x = y^2$
to obtain an equivalent integral $\int_0^{\sqrt{a}} f(y^2) 2 dy$ that has no singularity and will
therefore converge *much* more quickly.

If your integrand blows up (or has *any* singularity or discontinuity) in the *interior* of the integration domain,
you should *add an extra "endpoint"* at that point to make sure we never evaluate it.
(Also, `quadgk` can often converge more quickly if you tell it where your singularities
are via the endpoints.)  For example, suppose we are integrating
$\int_0^2 |x-1|^{-1/2} dx = 4$, which has an (integrable) singularity at $x=1$.
If we don't tell `quadgk` about the singularity, it gets "unlucky" and evaluates
the integrand exactly at $x=1$, which ends up throwing an error:
```julia-repl
julia> quadgk_count(x -> 1/sqrt(abs(x-1)), 0, 2)
ERROR: DomainError with 1.0:
integrand produced NaN in the interval (0, 2)
...
```
Instead, if we *tell* it to subdivide the integral at $x=1$, we get the correct answer(`≈ 4`):
```julia-repl
julia> quadgk_count(x -> 1/sqrt(abs(x-1)), 0, 1, 2)
(3.9999999643041515, 5.8392038954259235e-8, 2580)
```

In general, the syntax `quadgk(f, a, b, c, ...)` denotes the integral
$\int_a^b f(x)dx + \int_b^c f(x)dx  + \cdots$, and `quadgk` never evaluates
the integrand $f(x)$ exactly at the endpoints $a, b, c, \ldots$.

As another example, consider an integral $\int_0^3 H(x-1) = 2$ of the discontinuous
[Heaviside step function](https://en.wikipedia.org/wiki/Heaviside_step_function)
$H(x)$, which $=1$ when $x > 0$ and $=0$ when $x \le 0$:
```julia-repl
julia> quadgk_count(x -> x > 1, 0, 3)
(2.0000000043200235, 1.7916158219741817e-8, 705)
```
Even though $H(x-1)$ is nearly constant, `quadgk` struggles to integrate it (`705`
function evaluations to get about 8 digits), thanks to the discontinuity at $x=1$.
(Note that `true` and `false` in Julia are equal to numeric `0` and `1`, which is
why we could implement $H(x-1)$ as simply `x > 1`.)
On the other hand, if we *tell it* the location of the discontinuity:
```julia-repl
julia> quadgk_count(x -> x > 1, 0, 1, 3)
(2.0, 0.0, 30)
```
then it gives the *exact* answer in only 30 evaluations.  The reason it takes
30 evaluations is because `quadgk` defaults to 7th-order Gauss–Kronrod integration
rule, which uses 15 points to interpolate with a high-degree polynomial.  Once
we subdivide the integral, we could actually get away with a lower-order rule
by setting the `order` parameter, e.g.:
```julia-repl
julia> quadgk_count(x -> x > 1, 0, 1, 3, order=1)
(2.0, 0.0, 6)
```

## Complex and vector-valued integrands

The integrand `f(x)` can return not just real numbers, but also complex numbers, vectors, matrices, or any Julia type supporting `±`, multiplication by scalars, and `norm` (i.e. implementing any [Banach space](https://en.wikipedia.org/wiki/Banach_space)).

For example, we can integrate $1/\sqrt{x}$ from $x=-1$ to $x=1$, where we
[tell the `sqrt` function to return a complex result](https://docs.julialang.org/en/v1/manual/faq/#faq-domain-errors) for negative arguments:
```julia-repl
julia> quadgk(x -> 1/sqrt(complex(x)), -1, 0, 1)
(1.9999999891094182 - 1.9999999845983916im, 4.056765398346683e-8)
```
which correctly gives $\approx 2 - 2i$.  Note that we explicitly put an
endpoint at $x=0$ to tell `quadgk` about the singularity at that point,
as described above.

Or let's integrate the vector-valued function $f(x) = [1, x, x^2, x^3]$ for $x \in (0,1)$:
```julia-repl
julia> quadgk(x -> [1,x,x^2,x^3], 0, 1)
([1.0, 0.5, 0.3333333333333333, 0.25], 6.206335383118183e-17)
```
which correctly returns $\approx [1, \frac{1}{2}, \frac{1}{3}, \frac{1}{4}]$.  Note that the error estimate
in this case is an approximate bound on the [norm](https://en.wikipedia.org/wiki/Norm_(mathematics)) of the error, as computed by the [`LinearAlgebra.norm`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.norm) function in Julia.  It defaults to the Euclidean (L2) norm, but you can change this with the `norm`
argument:
```julia-repl
julia> quadgk(x -> [1,x,x^2,x^3], 0, 1, norm=v->maximum(abs, v))
([1.0, 0.5, 0.3333333333333333, 0.25], 5.551115123125783e-17)
```
e.g. to use the [maximum norm](https://en.wikipedia.org/wiki/Chebyshev_distance)
or some other norm (e.g. a weighted norm if the different components have different
units or have unequal error tolerances).

For integrands whose values are *small* arrays whose length is known at compile time,
it is [usually most efficient](https://docs.julialang.org/en/v1/manual/performance-tips/#Consider-StaticArrays.jl-for-small-fixed-size-vector/matrix-operations) to modify your integrand to return
an `SVector` from the [StaticArrays.jl package](https://github.com/JuliaArrays/StaticArrays.jl).  For the example above:
```julia-repl
julia> using StaticArrays

julia> integral, error = quadgk(x -> @SVector[1,x,x^2,x^3], 0, 1)
([1.0, 0.5, 0.3333333333333333, 0.25], 6.206335383118183e-17)

julia> typeof(integral)
SVector{4, Float64} (alias for SArray{Tuple{4}, Float64, 1, 4})
```
Note that the return value also gives the `integral` as an `SVector` (a [statically](https://en.wikipedia.org/wiki/Static_program_analysis) sized array).

The QuadGK package did not need any code specific to StaticArrays, and was
written long before that package even existed.  The fact that unrelated packages
like this can be [composed](https://en.wikipedia.org/wiki/Composability) is part
of the [beauty of multiple dispatch](https://www.youtube.com/watch?v=kc9HwsxE1OY)
and [duck typing](https://en.wikipedia.org/wiki/Duck_typing) for
[generic programming](https://en.wikipedia.org/wiki/Generic_programming).

## Batched integrand evaluation

User-side parallelization of integrand evaluations is also possible by providing
an in-place function of the form `f!(y,x) = y .= f.(x)`, which evaluates the
integrand at multiple points simultaneously. To use this API, `quadgk`
dispatches on a [`BatchIntegrand`](@ref) type containing `f!` and buffers for
`y` and `x`. These buffers may be pre-allocated and reused for multiple
`BatchIntegrand`s with the same domain and range types.

For example, we can perform multi-threaded integration of a highly oscillatory
function that needs to be refined globally:
```julia-repl
julia> f(x) = sin(100x)
f (generic function with 1 method)

julia> function f!(y, x)
           n = Threads.nthreads()
           Threads.@threads for i in 1:n
                y[i:n:end] .= f.(@view(x[i:n:end]))
           end
       end
f! (generic function with 1 method)

julia> quadgk(BatchIntegrand{Float64}(f!), 0, 1)
(0.0013768112771231598, 8.493080824940099e-12)
```

Batching also changes how the adaptive refinement is done, which typically leads
to slightly different results and sometimes more integrand evaluations. You
can limit the maximum batch size by setting the `max_batch` parameter
of the [`BatchIntegrand`](@ref), which can be useful in order to set an
upper bound on the size of the buffers allocated by `quadgk`.


## Arbitrary-precision integrals

`quadgk` also supports [arbitrary-precision arithmetic](https://en.wikipedia.org/wiki/Arbitrary-precision_arithmetic) using Julia's [`BigFloat` type](https://docs.julialang.org/en/v1/base/numbers/#BigFloats-and-BigInts) to compute integrals to arbitrary accuracy (albeit at increased computational cost).

For example, we can compute the [error function](https://en.wikipedia.org/wiki/Error_function) $\frac{\sqrt{\pi}}{2} \text{erf}(1) = \int_0^1 e^{-x^2} dx$ to 50 digits by:
```julia-repl
julia> setprecision(60, base=10) # use 60-digit arithmetic
60

julia> quadgk_count(x -> exp(-x^2), big"0.0", big"1.0", rtol=1e-50)
(0.74682413281242702539946743613185300535449968681260632902766195, 6.8956257635323481758755998484087241330474674891762053644928492e-51, 15345)
```
The correct answer is `≈ 0.746824132812427025399467436131853005354499686812606329027654498958605…`, and
we are matching that to nearly the full precision (≈ 60 digits).  (As usual,
the error estimate of `quadgk` is very conservative for smooth functions.)

Unfortunately, it took 15345 function evaluations to obtain such an accurate
answer.  Since this a smooth integrand, for high-accuracy calculations it is
often advisable to increase the "order" of the quadrature algorithm (which
is related to the degree of polynomials used for interpolation).  The default
is `order=7`, but let's try tripling it to `order=21`:
```julia-repl
julia> quadgk_count(x -> exp(-x^2), big"0.0", big"1.0", rtol=1e-50, order=21)
(0.74682413281242702539946743613185300535449968681260632902765324, 2.1873898701681913100611385149037136705674736373054902472850425e-58, 129)
```
It got the same accuracy (≈ 60 digits) with only 129 integrand evaluations!

## Contour integration

You can specify a sequence of points in the complex plane to perform a [contour integrals](https://en.wikipedia.org/wiki/Contour_integration) with `quadgk` along a piecewise-linear contour.

For example, consider the function $f(z) = \cos(z)/z$.  By the
[residue theorem](https://en.wikipedia.org/wiki/Residue_theorem)
of complex analysis, if we integrate counter-clockwise in a "loop"
around the [pole](https://en.wikipedia.org/wiki/Zeros_and_poles) at
$z=0$, we should get exactly $2\pi i \cos(0) = 2\pi i$.

One way to do this integral is to [parameterize a contour](https://en.wikipedia.org/wiki/Parametric_equation), say a
circle $|z|=1$ parameterized by $z= e^{i\phi}$ (`= cis(ϕ)` in Julia), which gives $dz = i z\, d\phi$, to
obtain an ordinary integral $\int_0^{2\pi} \frac{\cos(e^{i\phi})}{e^{i\phi}} ie^{i\phi} d\phi$ over the *real* parameter $\phi \in (0,2\pi)$:
```julia-repl
julia> quadgk(ϕ -> cos(cis(ϕ)) * im, 0, 2π)
(0.0 + 6.283185307179586im, 1.8649646913725044e-8)
```
which indeed gives us $\approx 2\pi i$ (to machine precision).

As an alternative, however, you can directly supply a sequence of
*complex "endpoints"* to `quadgk` and it will perform the contour
integral along a sequence of line segments connecting these points.  For example, instead of integrating around a circular contour, we can integrate
around the diamond (rotated square) connecting the corners $\pm 1$ and $\pm i$:
```julia-repl
julia> quadgk(z -> cos(z)/z, 1, im, -1, -im, 1)
(0.0 + 6.283185307179587im, 5.369976662961913e-9)
```
which again gives $\approx 2\pi i$ (to machine precision).  Note that it
is critically important to have a *closed* contour (a loop): the final
endpoint must be the same as the starting point ($z=1$).

## Cauchy principal values

Integrands $f(x) = g(x)/x$ that diverge $\sim 1/x$ cannot be integrated
through $x=0$ in the usual way (the singularity is not integrable).
However, if you integrate *around* $x=0$, for both signs of $x$, then you
can define a kind of integral that is the "difference" of the divergence
on the two sides.  This definition is called a [Cauchy principal value](https://en.wikipedia.org/wiki/Cauchy_principal_value), and is usually presented
as a limit:
```math
\text{p.v.}\int_a^b \frac{g(x)}{x} dx =
\lim_{\varepsilon\to 0^+} \left[
    \int_a^{-\varepsilon} \frac{g(x)}{x} dx + \int_{+\varepsilon}^b \frac{g(x)}{x} dx
\right] \, .
```
That is, you subtract a "ball" of radius $\varepsilon$ from the integration
domain $a < 0 < b$ to eliminate the singularity at $x=0$, and take the limit of the resulting integral as the $\varepsilon$ goes to zero.

In principle, you might imagine taking this limit numerically by
extrapolation of numerical integrals for a sequence of $\varepsilon > 0$
values, perhaps using Richardson extrapolation via the [Richardson.jl package](https://github.com/JuliaMath/Richardson.jl).  However, it is
mathematically equivalent and *much* more efficient to use a simple
singularity-subtraction procedure:
```math
\frac{g(x)}{x}  =
\frac{g(x)-g(0)}{x} + \frac{g(0)}{x}
```
where the first term is *not singular* if $g(x)$ is differentiable at $x=0$,
and the latter term can be integrated analytically, giving:
```math
\text{p.v.}\int_a^b \frac{g(x)}{x} dx = \int_a^b \frac{g(x)-g(0)}{x} dx +
g(0) \log|b/a|
```
Since the remaining integral has no singularity, we can do it numerically
directly.  There are two tricks to help us a bit further:

* As in [Integrands with singularities and discontinuities](@ref) above, we'll want to put an extra endpoint at $x=0$ to make sure `quadgk` doesn't evaluate the integrand exactly at that point (which would give `NaN` from $0/0$).
* We should be careful with the integration tolerances, to make sure that any relative tolerance `rtol` is applied with respect to the whole principal part and not just to the $g(x)-g(0)$ integral.  An easy way to do this is to add $g(0) \frac{\log|b/a|}{b-a}$ to the *integrand*, so that we no longer compute the two pieces separately.

Putting it all together, here is a function `cauchy_quadgk(g, a, b)` that
computes our Cauchy principal part $\text{p.v.}\int_a^b g(x)/x$:
```julia
function cauchy_quadgk(g, a, b; kws...)
    a < 0 < b || throw(ArgumentError("domain must include 0"))
    g₀ = g(0)
    g₀int = b == -a ? zero(g₀) : g₀ * log(abs(b/a)) / (b - a)
    return quadgk_count(x -> (g(x)-g₀)/x + g₀int, a, 0, b; kws...)
end
```
For example, [Mathematica tells us](https://www.wolframalpha.com/input?i=Integrate%5BCos%5Bx%5E2-1%5D%2Fx%2C+%7Bx%2C+-1%2C+2%7D%2C+PrincipalValue+-%3E+True%5D) that
```math
\text{p.v.} \int_{-1}^2 \frac{\cos(x^2-1)}{x} dx \approx 0.212451309942989788929352736695\ldots ,
```
and we can reproduce this with `cauchy_quadgk`:
```julia-repl
julia> cauchy_quadgk(x -> cos(x^2-1), -1, 2)
(0.21245130994298977, 1.8366794196644776e-11, 60)
```
which is correct to about 16 digits.

This approach and other approaches to computing Cauchy principal
values are discussed in [Keller and Wróbel (2016)](https://doi.org/10.1016/j.cam.2015.08.021).
This kind of "singularity subtraction" is a powerful approach to efficient
computation of integrals with singularities or near singularities.
A huge variety of related techniques have been developed for
[boundary element methods](https://en.wikipedia.org/wiki/Boundary_element_method), where a vast number of singular integrals
must be computed and efficiency is at a premium.  See, for example,
[Reid *et al.* (2014)](http://doi.org/10.1109/TAP.2014.2367492) and
references therein.

## Nearly singular integrands

Even if the integrand is only *nearly* singular, so that there is a
sharp but *finite* peak within the integration domain, it can greatly
increase the efficiency of numerical integration if you can separate
the sharp peak analytically.

For example, suppose that you are integrating:
```math
I = \int_a^b \frac{g(x)}{x - i\alpha} dx
```
for a small $0 < \alpha \ll 1$.  For $\alpha \to 0^+$, it approaches $i\pi g(0)$ plus a Cauchy principal part (the latter being zero if $a = -b$ and $g(x)=g(-x)$), but for small $\alpha > 0$ you have to numerically integrate (for a general function $g(x)$) a function with a sharp spike at $x=0$, which will require a large number of quadrature points.  But you can subtract out the singularity analytically:
```math
\begin{align*}
I &= \int_a^b \left[ \frac{g(x)-g(0)}{x - i\alpha} + \frac{g(0)}{x - i\alpha} \right] dx \\
&= \int_a^b \frac{g(x)-g(0)}{x - i\alpha}dx + \underbrace{g(0) \left[\frac{1}{2}\log(x^2 + \alpha^2) + i\tan^{-1}(x/\alpha) \right]_a^b}_{I_0}
\end{align*}
```
and then you only need to numerically integrate $I - I_0$, which has the spike subtracted.

As for [Cauchy principal values](@ref) above, we want to include
a $I_0 / (b-a)$ term directly in the integrand so that the error
tolerances are computed correctly, and include $x=0$ as an explicit
endpoint to let `quadgk` know that the integral is badly behaved there.

In code:
```julia
using QuadGK

function int_slow(g, α, a, b; kws...)
    if a < 0 < b
        # put an explicit endpoint at x=0 since we know it is badly behaved there
        return quadgk_count(x -> g(x) / (x - im*α), a, 0, b; kws...)
    else
        return quadgk_count(x -> g(x) / (x - im*α), a, b; kws...)
    end
end

function int_fast(g, α, a, b; kws...)
    g₀ = g(0)
    denom_int(x) = log(x^2 + α^2)/2 + im * atan(x/α)
    I₀ = g₀ * (denom_int(b) - denom_int(a))
    if a < 0 < b
        # put an explicit endpoint at x=0 since we know it is badly behaved there
        (I,E,c) = quadgk_count(x -> I₀/(b-a) + (g(x) - g₀) / (x - im*α), a, 0, b; kws...)
    else
        (I,E,c) = quadgk_count(x -> I₀/(b-a) + (g(x) - g₀) / (x - im*α), a, b; kws...)
    end
    return (I,E,c+1) # add 1 for g(0) evaluation
end
```
This gives:
```julia-repl
julia> int_slow(cos, 1e-6, -1, 1)
(1.1102230246251565e-16 + 3.1415896808206125im, 1.4895091715264936e-9, 1230)

julia> int_fast(cos, 1e-6, -1, 1)
(3.3306690738754696e-16 + 3.1415896808190418im, 1.8459683038047577e-12, 31)
```
which agree to about 13 digits, but the slow brute-force method requires 1230 function evaluations while the fast singularity-subtracted method requires only 31 function evaluations.

As an added bonus, `int_fast` works even for `α = 0`, where it gives you $i\pi g(0)$ (for $0 \in (a,b)$) plus the Cauchy principal part as above.

## Conditionally convergent integrals by Richardson extrapolation

Special care must be taken in numerical computation of integrals that are only [conditionally convergent](https://en.wikipedia.org/wiki/Conditional_convergence) — that is, the absolute value of the integrand is not integrable.  Because even the *definition* of such an integral can be changed by summing integrals over portions of the domain in different orders, they are problematic for h-adaptive quadrature methods that subdivide the domain into pieces that are evaluated in arbitrary order.   One such example is the [Dirichlet integral](https://en.wikipedia.org/wiki/Dirichlet_integral)
```math
\int_0^\infty \frac{\sin x}{x} dx = \frac{\pi}{2} \approx 1.57079632679\ldots \, ,
```
which is conditionally convergent because the integral of $|\sin x|/|x|$ diverges.  Applied naively, QuadGK gives an entirely incorrect answer for this integral:
```julia-repl
julia> quadgk_count(x -> sin(x)/x, 0, Inf)
(2.7708907564270895, 4.244645440962897, 1965)
```
Notice the enormouse error estimate: $2.77 \pm 4.24$!   The problem is that QuadGK is subdividing the domain into pieces that are summed in an arbitrary order, and from this perspective the integral is not defined—you *must* take the limit in a particular way.

One way to handle such integrals is to take a limit of a [Laplace transform](https://en.wikipedia.org/wiki/Laplace_transform):
```math
\lim_{s \to 0^+} \underbrace{\int_0^\infty e^{-sx} \frac{\sin x}{x} dx}_{\pi/2 - \arctan s} = \frac{\pi}{2} \, .
```
Here, the integral for $s > 0$ *is* absolutely convergent, unambiguously defined (it evaluates analytically to $\pi/2 - \arctan x$), and can be computed numerically by QuadGK without great difficulty, e.g. for $s=1$:
```julia-repl
julia> quadgk_count(x -> exp(-1*x) * sin(x)/x, 0, Inf)
(0.7853981633970302, 9.251635817418056e-10, 135)

julia> pi/2 - atan(1) # analytical answer
0.7853981633974483
```
which is correct to about 12 digits (for the default `rtol ≈ 1.5e-8`).   But how can one *numerically* take the limit $s \to 0^+$?

Because the Laplace transform of such integrands is analytic (has a Taylor series), it is natural to use a polynomial-extrapolation technique such as [Richardson extrapolation](https://en.wikipedia.org/wiki/Richardson_extrapolation), which is implemented in Julia
by the [Richardson.jl package](https://github.com/JuliaMath/Richardson.jl).  You give it a starting value of $s$, say $s=1$, and a tolerance, and it will extrapolate the $s \to 0^+$ for you (from evaluation at a sequence of $s$ values):
```julia-repl
julia> using Richardson

julia> extrapolate(1, rtol=1e-8) do s
           quadgk(x -> exp(-s*x) * sin(x)/x, 0, Inf, rtol=1e-10)[1]
       end
(1.5707963268036178, 4.397326947014335e-11)
```
which is the correct answer $\pi/2$ to about 11 significant digits.

As another example, let us consider the [Fresnel integral](https://en.wikipedia.org/wiki/Fresnel_integral), which is even more oscillatory and hence harder to compute accurately:
```math
\int_0^{\infty} \sin(x^2) dx = \sqrt{\frac{\pi}{8}} \approx 0.62665706865775\ldots \, .
```
This is again conditionally convergent (integrating the absolute value diverges).  Extrapolating as above, we obtain:
```julia-repl
julia> extrapolate(1, rtol=1e-4) do s
           quadgk(x -> exp(-s*x) * sin(x^2), 0, Inf, rtol=1e-10)[1]
       end
(0.6266287650288034, 0.017730230874649977)
```
which is accurate to about 4 significant digits.  It turns out to be difficult to do better than this in `Float64` precision due to the wildly oscillatory nature of this integrand.   For this sort of case one would be better off using a different quadrature method that is [analytically designed to compute oscillatory integrals](https://discourse.julialang.org/t/rfc-ann-oscillatoryintegralsode-jl-levin-method-ordinarydiffeq/55601).

# Gaussian quadrature and arbitrary weight functions

The manual chapter on [Gauss and Gauss–Kronrod quadrature rules](@ref) explains the fundamentals
of numerical integration ("quadrature") to approximate $\int_a^b f(x) dx$ by a weighted sum of
$f(x_i)$ values at quadrature points $x_i$.  Make sure you understand that chapter before reading
this one!

More generally, one can compute quadrature rules for
a **weighted** integral:
```math
\int_a^b W(x) f(x) dx \approx \sum_{i=1}^n w_i f(x_i) \, ,
```
where the effect of **weight function** $W(x)$ (usually required to be $≥ 0$ in ``(a,b)``) is
included in the quadrature weights $w_i$ and points $x_i$.  The main motivation
for weighted quadrature rules is to handle *poorly behaved* integrands — singular, discontinuous, highly oscillatory, and so on — where the "bad" behavior is *known*
and can be *factored out* into $W(x)$.  By designing a quadrature rule with $W(x)$
taken into account, one can obtain fast convergence as long as the remaining
factor $f(x)$ is smooth, regardless of how "bad" $W(x)$ is.  Moreover, the rule
can be re-used for many different $f(x)$ as long as $W(x)$ remains the same.

Gaussian quadrature is ideally suited to designing weighted quadrature rules, and QuadGK
includes functions to construct the points $x_i$ and weights $w_i$ for nearly any desired weight
function $W(x) \ge 0$, in principle, to any desired precision.   The case of Gauss–Kronrod rules (if you
want an error estimate) is a bit trickier: it turns out that Gauss–Kronrod rules may not exist
for arbitrary weight functions \[see the review in [Notaris (2016)](https://etna.ricam.oeaw.ac.at/vol.45.2016/pp371-404.dir/pp371-404.pdf)\], but if a (real-valued) rule *does* exist then QuadGK can compute it for you (to arbitrary precision) using an algorithm by [Laurie (1997)](https://www.ams.org/journals/mcom/1997-66-219/S0025-5718-97-00861-2/S0025-5718-97-00861-2.pdf).  You can specify the weight function $W(x)$ and the interval $(a,b)$ in one of two
ways:

* Via the [Jacobi matrix](https://en.wikipedia.org/wiki/Jacobi_operator) of the [orthogonal polynomials](https://en.wikipedia.org/wiki/Orthogonal_polynomials) associated with this weighted integral.  That may sound complicated, but it turns out that these are tabulated for many important weighted integrals.  For example, all of the weighted integrals in the [FastGaussQuadrature.jl](https://github.com/JuliaApproximation/FastGaussQuadrature.jl) package are based on well-known recurrences that you can look up easily.
* By explicitly providing the weight function $W(x)$, in which case QuadGK can perform a sequence of numerical integrals of $W(x)$ against polynomials (using `quadgk`) to numerically construct the Jacobi matrix and hence the Gauss or Gauss–Kronrod quadrature rule.  (This can be computationally expensive, especially to attain high accuracy, but it can still be worthwhile if you re-use the quadrature rule for many different $f(x)$ and/or $f(x)$ is extremely computationally expensive.)

## Weight functions and Jacobi matrices

For any weighted integral $I[f] = \int_a^b W(x) f(x)$ with non-negative $W(x)$, there is an associated set of [orthogonal polynomials](https://en.wikipedia.org/wiki/Orthogonal_polynomials) $p_k(x)$ of degrees $k = 0,1,\ldots$, such that $I[p_j p_k] = 0$ for $j \ne k$.   Amazingly,
the $n$-point Gaussian quadrature points $x_i$ are simply the roots of $p_n(x)$, and in general there is a
deep relationship between quadrature and the theory of orthogonal polynomials.   A key part of this theory
ends up being the [Jacobi matrix](https://en.wikipedia.org/wiki/Jacobi_operator) describing the three-term
recurrence of these polynomials for a given weighted integral.

It turns out that orthogonal polynomials always obey a three-term recurrence relationship
```math
p_{k+1}(x) = (a_k x + b_k)p_k(x) - c_k q_{k-1}(x)
```
for some coefficients $a_k > 0$, $b_k$, and $c_k>0$ that depend on the integral $I$. By a rescaling
$p_k = q_k \prod_{j<k} a_k$, this simplifies to:
```math
q_{k+1}(x) = (x - \alpha_k)q_k(x) - \beta_k q_{k-1}(x)
```
for  coefficients $\alpha_k = -b_k/a_k$ and $\beta_k = c_k/a_k a_{k-1} > 0$.  (Once you know these coefficients,
in fact, you can obtain all of the orthogonal polynomials by $q_{-1}=0, q_0=1, q_1=(x-\alpha_0), q_2=(x-\alpha_1)(x-\alpha_0) - \beta_1,\ldots$.)
The coefficients are also associated with an infinite real-symmetric tridiagonal ["Jacobi" matrix](https://en.wikipedia.org/wiki/Jacobi_operator):
```math
J = \begin{pmatrix}
\alpha_0 & \sqrt{\beta_1} & & & \\
\sqrt{\beta_1} & \alpha_1 & \sqrt{\beta_2} & & \\
& \sqrt{\beta_2} & \alpha_2 & \sqrt{\beta_3} & \\
& & \ddots & \ddots & \ddots
\end{pmatrix} .
```
Let $J_n$ be the $n \times n$ upper-left corner of $J$.   Astonishingly, the
quadrature points $x_i$ turn out to be exactly the eigenvalues of $J$, and the quadrature weights $w_i$
are the first components² of the corresponding normalized eigenvectors, scaled by $I[1]$ [(Golub & Welch, 1968)](https://www.ams.org/journals/mcom/1969-23-106/S0025-5718-69-99647-1/S0025-5718-69-99647-1.pdf)!

Given the $n \times n$ matrix $J_n$ (represented by a [`LinearAlgebra.SymTridiagonal`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.SymTridiagonal) object, which only stores the $\alpha_k$ and $\sqrt{\beta_k}$ coefficients) and the integral `unitintegral` $= I[1]$, you can construct the points $x_i$ and
weights $w_i$ of the $n$-point Gaussian quadrature rule in QuadGK via `x, w = gauss(Jₙ, unitintegral)`.  To construct
the $(2n+1)$-point Kronrod rule, then you need the $m \times m$ matrix $J_m$ where `m ≥ div(3n+3,2)` ($m \ge \lfloor (3n+3)/2 \rfloor$), and then obtain the points `x` and weights `w` (along with embedded Gauss weights `wg`) via `x, w, wg = kronrod(Jₘ, n, unitintegral)`.  Much of the time, you can simply look up formulas for the recurrence relations
for weight functions of common interest.   Hopefully, this will be clearer with some examples below.

### Gauss–Legendre quadrature via the Jacobi matrix

The common case of integrals $I[f] = \int_{-1}^{+1} f(x) dx$, corresponding to the weight function $W(x) = 1$ over
the interval $(-1,1)$, leads to the [Legendre polynomials](https://en.wikipedia.org/wiki/Legendre_polynomials):
```math
p_0(x) = 1, \; p_1(x) = x, \; p_2(x) = (3x^2 - 1)/2, \; \ldots
```
which satisfy the recurrence ([found on Wikipedia](https://en.wikipedia.org/wiki/Legendre_polynomials#Recurrence_relations) and in many other sources):
```math
(k+1)p_{k+1}(x) = (2k+1)x p_k(x) - k p_{k-1}(x) \, .
```
In the notation given above, that corresponds to coefficients $a_k = (2k+1)/(k+1)$, $b_k = 0$, and $c_k = k/(k+1)$,
or equivalently $\alpha_k = 0$ and $\beta_k = c_k/a_k a_{k-1} = k^2 / (4k^2 - 1)$, giving a Jacobi matrix:
```math
J = \begin{pmatrix}
0 & \sqrt{1/3} & & & \\
\sqrt{1/3} & 0 & \sqrt{4/15} & & \\
& \sqrt{4/15} & 0 & \sqrt{9/35} & \\
& & \ddots & \ddots & \ddots
\end{pmatrix} .
```
which can be constructed in Julia by
```julia-repl
julia> using LinearAlgebra # for SymTridiagonal

julia> J(n) = SymTridiagonal(zeros(n), [sqrt(k^2/(4k^2-1)) for k=1:n-1]) # the n×n matrix Jₙ
J (generic function with 1 method)

julia> J(5)
5×5 SymTridiagonal{Float64, Vector{Float64}}:
 0.0      0.57735    ⋅         ⋅         ⋅
 0.57735  0.0       0.516398   ⋅         ⋅
  ⋅       0.516398  0.0       0.507093   ⋅
  ⋅        ⋅        0.507093  0.0       0.503953
  ⋅        ⋅         ⋅        0.503953  0.0
```
The unit integral is simply $I[1] = \int_{-1}^{+1} dx = 2$, so we can construct our $n$-point Gauss rule with, for example:
```julia-repl
julia> x, w = gauss(J(5), 2); [x w]
5×2 Matrix{Float64}:
 -0.90618   0.236927
 -0.538469  0.478629
  0.0       0.568889
  0.538469  0.478629
  0.90618   0.236927
```
This is, of course, the same as the "standard" Gaussian quadrature rule, returned by `gauss(n)`:
```julia-repl
julia> x, w = gauss(5); [x w]
5×2 Matrix{Float64}:
 -0.90618   0.236927
 -0.538469  0.478629
  0.0       0.568889
  0.538469  0.478629
  0.90618   0.236927
```
Similarly, the 5-point Gauss–Kronrod rule can be constructed from the $9\times 9$ Jacobi matrix ($9 = (3n+3)/2$):
```julia-repl
julia> x, w, wg = kronrod(J(9), 5, 2); [x w]
11×2 Matrix{Float64}:
 -0.984085  0.042582
 -0.90618   0.115233
 -0.754167  0.186801
 -0.538469  0.24104
 -0.27963   0.27285
  0.0       0.282987
  0.27963   0.27285
  0.538469  0.24104
  0.754167  0.186801
  0.90618   0.115233
  0.984085  0.042582
```
which is the same as the "standard" Gauss–Kronrod rule returned by `kronrod(n)` (returning only the $x_i \le 0$ points) or `kronrod(n, -1, +1)` (returning all the points):
```julia-repl
julia> x, w, wg = kronrod(5); [x w]
6×2 Matrix{Float64}:
 -0.984085  0.042582
 -0.90618   0.115233
 -0.754167  0.186801
 -0.538469  0.24104
 -0.27963   0.27285
  0.0       0.282987
```

Notice that, in this case, our Jacobi matrix had zero diagonal entries $\alpha_k = 0$.
It turns out that this *always* happens when the integration is centered around zero
(``a=-b``) and the weight function $W(x)$ that is *symmetric* (``W(x)=W(-x)``).
This is called a "hollow" tridiagonal matrix, and its eigenvalues always come in
$\pm x_j$ pairs: the quadrature rule is has *symmetric points and weights*.
In this case QuadGK can do its computations a bit more efficiently, and only
compute the non-redundant $x_i \le 0$ half of of the quadrature rule, if you
represent $J_n$ with a special type [`QuadGK.HollowSymTridiagonal`](@ref) whose
constructor only requires you to supply the off-diagonal elements $\sqrt{\beta_k}$:
```julia-repl
julia> JholloW(n) = QuadGK.HollowSymTridiagonal([sqrt(k^2/(4k^2-1)) for k=1:n-1])
Jhollow (generic function with 1 method)

julia> JholloW(5)
5×5 QuadGK.HollowSymTridiagonal{Float64, Vector{Float64}}:
  ⋅       0.57735    ⋅         ⋅         ⋅
 0.57735   ⋅        0.516398   ⋅         ⋅
  ⋅       0.516398   ⋅        0.507093   ⋅
  ⋅        ⋅        0.507093   ⋅        0.503953
  ⋅        ⋅         ⋅        0.503953   ⋅

julia> x, w = gauss(JholloW(5), 2); [x w]
5×2 Matrix{Float64}:
 -0.90618   0.236927
 -0.538469  0.478629
  0.0       0.568889
  0.538469  0.478629
  0.90618   0.236927

julia> x, w, wg = kronrod(JholloW(9), 5, 2); [x w] # only returns xᵢ ≤ 0 points:
6×2 Matrix{Float64}:
 -0.984085  0.042582
 -0.90618   0.115233
 -0.754167  0.186801
 -0.538469  0.24104
 -0.27963   0.27285
  0.0       0.282987
```
(The `gauss` function returns all the points, albeit computed more efficiently,
while the `kronrod` function returns only the $x_i \le 0$ points for a `HollowSymTridiagonal` Jacobi matrix.)

If you have the Jacobi matrix for one interval, but want QuadGK to rescale the
quadrature points and weights to some other interval (rather than doing the change
of variables yourself), you can use the method `gauss(J, unitintegral,  (a,b) => (newa, newb))`, where
`(newa,newb)` is the new interval and `unitintegral` is the integral of $f(x)=1$ over
the new interval, and similarly for `kronrod`.  For example, to rescale the
Legendre $W(x)=1$ rule from $(-1,+1)$ to the interval $(4,7)$, with unit
integral $7-4 = 3$, we could do:
```julia-repl
julia> x, w = gauss(JholloW(5), 3, (-1,1) => (4,7)); [x w]
5×2 Matrix{Float64}:
 4.14073  0.35539
 4.6923   0.717943
 5.5      0.853333
 6.3077   0.717943
 6.85927  0.35539

julia> x, w = kronrod(JholloW(9), 5, 3, (-1,1) => (4,7)); [x w]
11×2 Matrix{Float64}:
 4.02387  0.0638731
 4.14073  0.17285
 4.36875  0.280201
 4.6923   0.361561
 5.08055  0.409275
 5.5      0.424481
 5.91945  0.409275
 6.3077   0.361561
 6.63125  0.280201
 6.85927  0.17285
 6.97613  0.0638731
```
(When the result is rescaled to a new interval, both functions return all of the points, but
they are still computed more efficiently for a `HollowSymTridiagonal` Jacobi matrix.)

### Gauss–Jacobi quadrature via the Jacobi matrix

A typical application of weighted quadrature rules is to accelerate convergence for
integrands that have power-law singularities at one or both of the endpoints.  Without
loss of generality, we can rescale the interval to $(-1,+1)$, in which case such
integrals are of the form:
```math
I[f] = \int_{-1}^{+1} \underbrace{(1-x)^\alpha (1+x)^\beta}_{W(x)} f(x) dx \, ,
```
where $\alpha > -1$ and $\beta > -1$ are the power laws at the two endpoints, which
we have factored out into a weight function $W(x) = (1+x)^\alpha (1-x)^\beta$ multiplied
by some (hopefully smooth) function $f(x)$.  For example, $\alpha = 0.5$ means that
there is a square-root singularity at $x=+1$ (where the integrand is finite,
but its slope blows up).  Or if $\beta = -0.1$ then
the integrand blows up at $x=-1$ but the integral is still finite (``1/x^{0.1}`` is an "integrable singularity").
This weight function is quite well known, in fact:
it yields [Gauss–Jacobi quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Jacobi_quadrature),
with the corresponding orthogonal polynomials being the [Jacobi polynomials](https://en.wikipedia.org/wiki/Jacobi_polynomials).

Again, we can simply look up the 3-term recurrence for the Jacobi polynomials $p_n$
corresponding to this weight function:
```math
2k (k + \alpha + \beta) (2k + \alpha + \beta - 2) p_k(x) = (2k+\alpha + \beta-1) \Big\{ (2k+\alpha + \beta)(2k+\alpha+\beta-2) x +  \alpha^2 - \beta^2 \Big\} p_{k-1}(x) - 2 (k+\alpha - 1) (k + \beta-1) (2k+\alpha + \beta) p_{k-2}(x),
```
giving $\alpha_k$ and $\beta_k$ by the earlier formulas, after a bit of algebra.
We also will need the unit integral
```math
I[1] = \int_{-1}^{+1} (1+x)^\alpha (1-x)^\beta dx  = \frac{2^{\alpha + \beta + 1}}{\alpha + \beta + 1} \frac{\Gamma(\alpha+1)\Gamma(\beta+1)}{\Gamma(\alpha+\beta+1)} \, ,
```
where $\Gamma$ is the [Gamma function](https://en.wikipedia.org/wiki/Gamma_function),
computed in Julia by [SpecialFunctions.jl](https://github.com/JuliaMath/SpecialFunctions.jl).
This is all rather tedious, but fortunately exactly these expressions have already been worked out for
us by the [FastGaussQuadrature.jl](https://github.com/JuliaApproximation/FastGaussQuadrature.jl) package,
in undocumented functions `FastGaussQuadrature.jacobi_jacobimatrix(n, α, β)`
(which computes the Jacobi matrix $J_n$) and `FastGaussQuadrature.jacobimoment(α, β)` (which computes $I[1]$).

We can use these to immediately compute the Gauss and Gauss–Kronrod points and weights
for the Jacobi weight function, say for $\alpha = 0.5$, $\beta = -0.1$, and $n=5$:
```julia-repl
julia> using FastGaussQuadrature, QuadGK

julia> α, β, n = 0.5, -0.1, 5;

julia> Jₙ = FastGaussQuadrature.jacobi_jacobimatrix(n, α, β)
5×5 LinearAlgebra.SymTridiagonal{Float64, Vector{Float64}}:
 -0.25       0.525105     ⋅            ⋅            ⋅
  0.525105  -0.0227273   0.506534      ⋅            ⋅
   ⋅         0.506534   -0.00852273   0.503003      ⋅
   ⋅          ⋅          0.503003    -0.00446429   0.501725
   ⋅          ⋅           ⋅           0.501725    -0.00274725

julia> I₁ = FastGaussQuadrature.jacobimoment(α, β)
2.012023098289125

julia> x, w = gauss(Jₙ, I₁); [x w]
5×2 Matrix{Float64}:
 -0.923234   0.372265
 -0.589357   0.610968
 -0.0806012  0.574759
  0.452539   0.349891
  0.852191   0.10414
```
(Notice that this weight function is *not* symmetric, and so the Jacobi matrix
is *not* hollow and the quadrature points and weights are asymmetrically
distributed: the  points are denser near $x=-1$ where the weight function diverges.)
These are the same as the Gauss points and weights returned by the `gaussjacobi`
function in FastGaussQuadrature (which has fancy algorithms that scale better for
large `n` than those in QuadGK):
```julia-repl
julia> xf, wf = FastGaussQuadrature.gaussjacobi(n, α, β); [xf wf]
5×2 Matrix{Float64}:
 -0.923234   0.372265
 -0.589357   0.610968
 -0.0806012  0.574759
  0.452539   0.349891
  0.852191   0.10414

julia> [x w] - [xf wf] # they are same points/weights to nearly machine precision
5×2 Matrix{Float64}:
  0.0           3.33067e-16
  0.0           0.0
 -1.38778e-17  -2.22045e-16
  5.55112e-17  -2.77556e-16
 -1.11022e-16   9.71445e-17
```
However, QuadGK can also return the 12-point Gauss–Kronrod rule, which embeds/
extends the 5-point Gauss-Jacobi rule in order to give you an error estimate:
```julia-repl
julia> J₁₂ = FastGaussQuadrature.jacobi_jacobimatrix(12, α, β);

julia> kx, kw, wg = kronrod(J₁₂, n, I₁); [kx kw]
11×2 Matrix{Float64}:
 -0.988882   0.0723663
 -0.923234   0.181321
 -0.786958   0.264521
 -0.589357   0.306879
 -0.347734   0.311949
 -0.0806012  0.286857
  0.192962   0.238356
  0.452539   0.175128
  0.677987   0.109024
  0.852191   0.0520297
  0.962303   0.0135914

julia> [ kx[2:2:end] wg ]  # embedded Gauss–Jacobi rule is a subset x₂ᵢ of the points
5×2 Matrix{Float64}:
 -0.923234   0.372265
 -0.589357   0.610968
 -0.0806012  0.574759
  0.452539   0.349891
  0.852191   0.10414
```

The whole point of this is to accelerate convergence for smooth $f(x)$.  For
example, let's consider $f(x) = \cos(2x)$ with $\alpha = 0.5, \beta = -0.1$ as above.
In this case, according to Mathematica, the correct integral to 100 decimal places is
$I[\cos(2x)] \approx 0.9016684424525614794498545355301765224191593237834490575027527594933568786176710824696779907143025232764922385146156$, or about `0.9016684424525615` to machine precision.  If we use
the default `quadgk` function, which uses adaptive Gauss–Kronrod quadrature that doesn't
have the singularity built-in, it takes about 1000 function evaluations to reach 9 digits of accuracy:
```julia-repl
julia> exact = 0.9016684424525615;

julia> I, _ = quadgk_count(x -> (1-x)^α * (1+x)^β * cos(2x), -1, 1, rtol=1e-9)
(0.9016684425015659, 6.535590698106445e-10, 1125)

julia> I - exact
4.900435612853471e-11
```
(This isn't too terrible! If we plotted the points where `quadgk` evaluates our integrand,
we would see that it concentrates points mostly close to the singularities at the boundaries.
To get a similar error from unweighted Gauss–Legendre quadrature requires about $n=10^5$ points,
which is too slow with the `gauss(n)` function — it's only practical with `x, w = FastGaussQuadrature.gausslegendre(10^5)`,
which uses a fancy $O(n)$ algorithm.  Ordinary Gaussian quadrature very slowly converging for non-smooth functions.)
In contrast, our 5-point Gauss–Jacobi quadrature rule from above gets about 6 digits:
```julia-repl
julia> I = sum(@. cos(2x) * w)
0.9016690323443182

julia> I - exact
5.898917566637962e-7
```
and gets 10 digits with only 7 points:
```julia-repl
julia> x, w = gauss(FastGaussQuadrature.jacobi_jacobimatrix(7, α, β), I₁);

julia> I = sum(@. cos(2x) * w)
0.9016684424777912

julia> I - exact
2.522970721230422e-11
```
This is not unexpected, because the fact that $f(x)$ is smooth means that Gaussian
quadrature converges exponentially fast, regardless of the weight function's endpoint
singularities (which have been taken into account analytically by the quadrature rule).
The Gauss–Kronrod rule also converges exponentially, and gives us an error estimate
to give us added confidence in the result.  For example, with our 12-point
Gauss–Kronrod rule we obtain the correct result to machine precision:
```julia-repl
julia> Ik = sum(@. cos(2kx) * kw)
0.9016684424525613

julia> Ik - exact
-2.220446049250313e-16
```
while a subset `kx[2:2:end]` of the points (for which we could re-use the
integrand evaluations if we wanted) gives us an embedded Gauss rule and an
error bound:
```julia-repl
julia> Ig = sum(@. cos(2kx[2:2:end]) * wg)
0.9016690323443182

julia> abs(Ik - Ig) # conservative error estimate: Kronrod - Gauss
5.898917568858408e-7
```
As usual, this error bound is quite conservative for smooth $f(x)$ where the quadrature rule is converging rapidly, since it is actually an error estimate for the 5-point `Ig` and not for the 12-point `Ik`.  But at least it gives you some indication as to whether you picked a sufficient number of points to integrate $f(x)$ sufficiently accurately.

For fun, let's do the same calculation to 100 digits with $n=11$, using `BigFloat` arithmetic.  (We simple need to pass `big"0.5"` and `big"-0.1"` for `α` and `β` to FastGaussQuadrature and it will construct the Jacobi matrix in `BigFloat` precision, which QuadGK will then turn into `BigFloat` Gauss/Gauss–Kronrod points and weights.)
```julia-repl
julia> setprecision(100, base=10)
100

julia> bigexact = big"0.9016684424525614794498545355301765224191593237834490575027527594933568786176710824696779907143025232764922385146156"
0.901668442452561479449854535530176522419159323783449057502752759493356878617671082469677990714302523252

julia> bigJ = FastGaussQuadrature.jacobi_jacobimatrix(18, big"0.5", big"-0.1");

julia> bigI₁ = FastGaussQuadrature.jacobimoment(big"0.5", big"-0.1")
2.01202309828912479732166203322245014347199888907111184953347045850828228938420405746115463698460502738

julia> bigkx, bigkw, bigwg = kronrod(bigJ, 11, bigI₁);

julia> bigIk = sum(@. cos(2bigkx) * bigkw)
0.901668442452561479449854535530176522419159355847389937592609530571246098597677208391320749304692456157

julia> Float64(bigIk - bigexact)
3.2063940880089856e-44
```
so the 18-point Gauss–Kronrod rule is accurate to about 43 digits, while the conservative error estimate (= error of embedded 11-point Gauss rule) is about 20 digits:
```julia-repl
julia> bigIg = sum(@. cos(2bigkx[2:2:end]) * bigwg)
0.901668442452561479451864506089616011729536201879100045019491743663463853013435135385929850010604582451

julia> Float64(abs(bigIk - bigIg))
2.0099705594394893e-21
```

## Arbitrary weight functions

Although analytical formulas for 3-term recurrences and Jacobi matrices are known for many common types of singularities that appear in integrals, this is certainly not universally true.   As a fallback, you can simply supply an arbitrary weight function $W(x)$ and let QuadGK compute everything for you numerically (essentially by a form of [Gram–Schmidt process](https://en.wikipedia.org/wiki/Gram%E2%80%93Schmidt_process) in which a basis of polynomials is orthonormalized with respect to $w$, using a sequence of $O(n)$ numerical integrals).   This is much more time consuming, especially if you want high accuracy (i.e. you specify a low tolerance for the numerical integrals), but can be worth it if your $f(x)$ is expensive and/or you need many integrals of a similar form:  the numerical integrals are against cheap polynomial functions, and are only done once for all $f(x)$ with the same weight function.

For example:
```julia
using QuadGK
x, w = gauss(x -> exp(-x) / sqrt(x), 10, 0, -log(1e-10), rtol=1e-9)
```
computes the points and weights for performing `∫exp(-x)f(x)/√x dx` integrals from `0` to `-log(1e-10) ≈ 23`, so that there is a `1/√x` singularity in the integrand at `x=0` and a rapid decay for increasing `x`.  (The `gauss` function currently does not support infinite integration intervals, but for a rapidly decaying weight function you can approximate an infinite interval to any desired accuracy by a sufficiently broad interval, with a tradeoff in computational expense.)  For example, with `f(x) = sin(x)`, the exact answer is `0.570370556005742…`.  Using the points and weights above with `sum(sin.(x) .* w)`, we obtain `0.5703706212868831`, which is correct to 6–7 digits using only 10 `f(x)` evaluations.  Obtaining similar
accuracy for the same integral from `quadgk` requires nearly 300 function evaluations.   However, the
`gauss` function itself computes many (``2n``) numerical integrals of your weight function (multiplied
by polynomials), so this is only more efficient if your `f(x)` is very expensive or if you need
to compute a large number of integrals with the same `W`.  See the [`gauss`](@ref) documentation for more information.

Similarly, one can use the `kronrod(W, n, a, b, rtol=rtol)` function to construct Gauss–Kronrod rules
for arbitrary weight functions.   Unfortunately, it turns out that a Gauss–Kronrod rule does not exist for the weight function above, and the `kronrod` function consequently throws an error — probably because it is very similar to [Gauss–Laguerre quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Laguerre_quadrature) and Gauss–Kronrod rules are known to not exist for the Gauss–Laguerre problem [(Kahaner & Monegato, 1978)](https://doi.org/10.1007/BF01590820).   However, we can for example reproduce the points and weights from the Gauss–Jacobi weight function of the previous section, now computed completely numerically without supplying the analytical Jacobi matrix:
```julia-repl
julia> kx, kw, wg = kronrod(x -> (1-x)^0.5 * (1+x)^-0.1, 5, -1, 1, rtol=1e-9); [kx kw]
11×2 Matrix{Float64}:
 -0.988882   0.0723663
 -0.923234   0.181321
 -0.786958   0.264521
 -0.589357   0.306879
 -0.347734   0.311949
 -0.0806012  0.286857
  0.192962   0.238356
  0.452539   0.175128
  0.677987   0.109024
  0.852191   0.0520297
  0.962303   0.0135914
```
(If you compare these more quantitatively to those in the previous section, you'll see that they
are accurate to about 10 digits, consistent with the `rtol=1e-9` that we passed as a tolerance
for the numerical integrals used in constructing the Jacobi matrix numerically.)

For a more practical example that can *only* be done numerically, see our tutorial using a [weight function interpolated from tabulated solar-spectrum data](https://nbviewer.jupyter.org/urls/math.mit.edu/~stevenj/Solar-Quadrature.ipynb), also described in [Johnson (2019)](https://arxiv.org/abs/1912.06870).

# Gauss and Gauss–Kronrod quadrature rules

The foundational algorithm of the QuadGK package is a
[Gauss–Kronrod quadrature rule](https://en.wikipedia.org/wiki/Gauss%E2%80%93Kronrod_quadrature_formula), an extension of
[Gaussian quadrature](https://en.wikipedia.org/wiki/Gaussian_quadrature).
In this chapter of
the QuadGK manual, we briefly explain what these are, and describe how
you can use QuadGK to generate your own Gauss and Gauss–Kronrod rules,
including for more complicated weighted integrals.

## Quadrature rules and Gaussian quadrature

A **quadrature rule** is simply a way to approximate an integral by
a sum:
```math
\int_a^b f(x) dx \approx \sum_{i=1}^n w_i f(x_i)
```
where the $n$ evaluation points $x_i$ are known as the **quadrature points**
and the coefficients $w_i$ are the **quadrature weights**.   We typically
want to design quadrature rules that are as accurate as possible for
as small an `n` as possible, for a wide range of functions $f(x)$ (for
example, for [smooth functions](https://en.wikipedia.org/wiki/Smoothness)).
The underlying assumption is that evaluating the integrand $f(x)$ is
computationally expensive, so you want to do this as few times as possible
for a given error tolerance.

There are [many numerical-integration techniques](https://en.wikipedia.org/wiki/Numerical_integration) for designing quadrature rules.  For example,
one could simply pick the points $x_i$ uniformly at random in $(a,b)$ and
use a weight $w_i = 1/n$ to take the average — this is [Monte-Carlo integration](https://en.wikipedia.org/wiki/Monte_Carlo_method), which is
simple but converges rather slowly (its error scales as $\sim 1/\sqrt{n}$).

A particularly efficient class of quadrature rules is known as
[Gaussian quadrature](https://en.wikipedia.org/wiki/Gaussian_quadrature),
which exploits the remarkable theory of [orthogonal polynomials](https://en.wikipedia.org/wiki/Orthogonal_polynomials) in order to design $n$-point
rules that *exactly* integrate all polynomial functions $f(x)$ up to degree
$2n-1$.  More importantly, the error goes to zero extremely rapidly
even for non-polynomial $f(x)$, as long as $f(x)$ is sufficiently smooth.
(They converge *exponentially* rapidly for [analytic functions](https://en.wikipedia.org/wiki/Analytic_function).)  There are many variants of
Gaussian quadrature, as we will discuss further below, but the specific
case of computing $\int_{-1}^{1} f(x) dx$ is known as [Gauss–Legendre quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Legendre_quadrature), and $\int_a^b f(x) dx$ over other
intervals $(a,b)$ is equivalent to Gauss–Legendre under a simple
change of variables (given explicitly below).

The QuadGK package can compute the points $x_i$ and weights $w_i$ of a Gauss–Legendre quadrature rule (optionally rescaled to an arbitrary interval ``(a,b)``) for you via the [`gauss`](@ref) function.
For example, the $n=5$ point rule for integrating from $a=1$ to $b=3$
is computed by:
```julia-repl
julia> a = 1; b = 3; n = 5;

julia> x, w = gauss(n, a, b);

julia> [x w] # show points and weights as a 2-column matrix
5×2 Matrix{Float64}:
 1.09382  0.236927
 1.46153  0.478629
 2.0      0.568889
 2.53847  0.478629
 2.90618  0.236927
```
We can see that there are 5 points $a < x_i < b$.  They are *not* equally spaced or equally weighted, nor do they quite reach the endpoints.  We can now approximate integrals by evaluating the integrand $f(x)$ at these points, multiplying by the weights, and summing.  For example, $f(x)=\cos(x)$ can be integrated via:
```julia-repl
julia> sum(w .* cos.(x)) # evaluate ∑ᵢ wᵢ f(xᵢ)
-0.7003509770773674

julia> sin(3) - sin(1)   # the exact integral
-0.7003509767480293
```
Even with just $n = 5$ points, Gaussian quadrature can integrate such
a smooth function as this to 8–9 significant digits!

The `gauss` function allows you to compute Gaussian quadrature
rules to any desired precision, even supporting [arbitrary-precision arithmetic](https://en.wikipedia.org/wiki/Arbitrary-precision_arithmetic) types such as `BigFloat`.  For example, we can compute the same rule as above to about 30 digits:
```julia-repl
julia> setprecision(30, base=10);

julia> x, w = gauss(BigFloat, n, a, b); @show x; @show w;
x = BigFloat[1.0938201540613360072023731217019, 1.4615306898943169089636855793001, 2.0, 2.5384693101056830910363144207015, 2.9061798459386639927976268782981]
w = BigFloat[0.23692688505618908751426404072106, 0.47862867049936646804129151483584, 0.56888888888888888888888888888975, 0.47862867049936646804129151483584, 0.23692688505618908751426404072106]
```
This allows you to compute numerical integrals to very high accuracy if you want.  (The [`quadgk`](@ref) function also supports arbitrary-precision arithmetic types.)

## Gauss–Kronrod: Error estimation and embedded rules

A good quadrature rule is often not enough: you also want
to have an **estimate of the error** for a given $f(x)$, in order to
decide whether you are happy with your approximate integral or if you
want to get a more accurate estimate by increasing $n$.

The most basic way to do this is to evaluate *two* quadrature rules, one with
fewer points $n' < n$, and use their *difference* as an error
estimate.  (If the error is rapidly converging with $n$, this is usually
a conservative upper bound on the error.)
```math
\text{error estimate} = \Bigg|
\underbrace{\sum_{i=1}^n w_i f(x_i)}_{\text{first rule}} -
\underbrace{\sum_{j=1}^{n'} w_j' f(x_j')}_{\text{second rule}}
\Bigg|
```
Naively, this requires us to evaluate our integrand $f(x)$ an extra
$n'$ times to get the error estimate from the second rule.  However,
we can do better: if the points $\{ x_j' \}$ of the second ($n'$-point) rule
are a *subset* of the points $\{ x_i \}$ of the points from the first
($n$-point) rule, then we only need $n$ function evaluations for the
first rule and can *re-use* them when evaluating the second rule.
This is called an **embedded** (or **nested**) quadrature rule.

There are many ways of designing embedded quadrature rules.  Unfortunately,
the nice Gaussian quadrature rules cannot be directly nested: the $n'$-point
Gaussian quadrature points are *not* a subset of the $n$-point Gaussian
quadrature points for *any* $1 < n' < n$.   Fortunately, there is a slightly
modified scheme that works, called [Gauss–Kronrod quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Kronrod_quadrature_formula): if you start with an $n'$-point Gaussian-quadrature scheme, you can extend it with
$n'+1$ additional points to obtain a quadrature scheme with $n=2n'+1$
points that exactly integrates polynomials up to degree $3n'+1$.
Although this is slightly worse than an $n$-point Gaussian quadrature
scheme, it is still quite accurate, still converges very fast
for smooth functions, and gives you a built-in error estimate that
requires no additional function evaluations.   (In QuadGK, we refer
to the size $n'$ of the embedded Gauss rule as the "order", although
other authors use that term to refer to the degree of polynomials
that are integrated exactly.)

The [`quadgk`](@ref) function uses Gauss–Kronrod quadrature internally,
defaulting to order $n'=7$ (i.e. $n=15$ points), though you can change
this with the `order` parameter.   This gives it both an estimated
integral and an estimated error.  If the error is larger than your requested
tolerance, `quadgk` splits the integration interval into two halves and
applies the same Gauss–Kronrod rule to each half, and continues to
subdivide the intervals until the desired tolerance is achieved, a
process called $h$-[adaptive quadrature](https://en.wikipedia.org/wiki/Adaptive_quadrature).  (An alternative called $p$-adaptive quadrature
would increase the order $n'$ on the same interval.  $h$-adaptive
quadrature is more robust if your function has localized bad behaviors
like sharp peaks or discontinuities, because it will progressively
add more points mostly in these "bad" regions.)

You can use the [`kronrod`](@ref) function to compute a Gauss–Kronrod
rule to any desired order (and to any precision).  For example, we can extend our 5-point Gaussian-quadrature rule for $\int_1^3$ from the previous section to an 11-point (`2n+1`) Gauss-Kronrod rule:
```julia-repl
julia> x, w, wg = kronrod(n, a, b); [ x w ] # points and weights
11×2 Matrix{Float64}:
 1.01591  0.042582
 1.09382  0.115233
 1.24583  0.186801
 1.46153  0.24104
 1.72037  0.27285
 2.0      0.282987
 2.27963  0.27285
 2.53847  0.24104
 2.75417  0.186801
 2.90618  0.115233
 2.98409  0.042582
```
Similar to Gaussian quadrature, notice that all of the Gauss–Kronrod points
$a < x_i < b$ lie in the interior $(a,b)$ of our integration interval,
and that they are unequally spaced (clustered more near the edges).
The third return value, `wg`, gives the weights of the embedded 5-point
Gaussian-quadrature rule, which corresponds to the *even-indexed* points
`x[2:2:end]` of the 11-point Gauss–Kronrod rule:
```julia-repl
julia> [ x[2:2:end] wg ] # embedded Gauss points and weights
5×2 Matrix{Float64}:
 1.09382  0.236927
 1.46153  0.478629
 2.0      0.568889
 2.53847  0.478629
 2.90618  0.236927
```
So, we can evaluate our integrand $f(x)$ at the 11 Gauss–Kronrod points, and then re-use 5 of these values to obtain an error estimate.  For example, with $f(x) = \cos(x)$, we obtain:
```julia-repl
julia> fx = cos.(x); # evaluate f(xᵢ)

julia> integral = sum(w .* fx) # ∑ᵢ wᵢ f(xᵢ)
-0.7003509767480292

julia> error = abs(integral - sum(wg .* fx[2:2:end])) # |integral - ∑ⱼ wⱼ′ f(xⱼ′)|
3.2933822335934337e-10

julia> abs(integral - (sin(3) - sin(1))) # true error ≈ machine precision
1.1102230246251565e-16
```
As noted above, the error estimate tends to actually be quite a conservative
upper bound on the error, because it is effectively a measure of the error of the lower-order *embedded* 5-point Gauss rule rather than that of the higher-order 11-point Gauss–Kronrod rule.  For smooth functions like $\cos(x)$, an 11-point rule can have an error orders of magnitude smaller than that of the 5-point rule.  (Here, the 11-point rule's accuracy
is so good that it is actually limited by [floating-point roundoff error](https://en.wikipedia.org/wiki/Machine_epsilon); in infinite precision the error would have been `≈ 6e-23`.)

You may notice that both the Gauss–Kronrod and the Gaussian quadrature
rules are *symmetric* around the center $(a+b)/2$ of the integration interval.   In fact, we provide a lower-level function `kronrod(n)` that only computes roughly the first half of the points and weights for $\int_{-1}^{1}$ ($b = -a = 1$), corresponding to $x_i \le 0$.
```julia-repl
julia> x, w, wg = kronrod(5); [x w] # points xᵢ ≤ 0 and weights
6×2 Matrix{Float64}:
 -0.984085  0.042582
 -0.90618   0.115233
 -0.754167  0.186801
 -0.538469  0.24104
 -0.27963   0.27285
  0.0       0.282987

julia> [x[2:2:end] wg] # embedded Gauss points ≤ 0 and weights
3×2 Matrix{Float64}:
 -0.90618   0.236927
 -0.538469  0.478629
  0.0       0.568889
```
Of course, you still have to evaluate $f(x)$ at all $2n+1$ points,
but summing the results requires a bit less arithmetic
and storing the rule takes less memory.  Note also that the $(-1,1)$ rule can be applied to any desired interval $(a,b)$ by a change of variables
```math
\int_a^b f(x) dx = \frac{b-a}{2} \int_{-1}^{+1} f{\left( (u+1)\frac{b-a}{2} + a \right)} du \, ,
```
so the $(-1,1)$ rule can be computed once (for a given order and precision) and re-used.  In consequence, `kronrod(n)` is `quadgk` uses internally.  The higher-level `kronrod(n, a, b)` function is more convenient for casual use, however.

As with `gauss`, the `kronrod` function works with arbitrary precision,
such as `BigFloat` numbers.  `kronrod(n, a, b)` uses the precision of
the endpoints `(a,b)` (converted to floating point), while for
`kronrod(n)` you can explicitly pass a floating-point type `T` as
the first argument, e.g. for 50-digit precision:
```julia-repl
julia> setprecision(50, base=10); x, w, wg = kronrod(BigFloat, 5); x
6-element Vector{BigFloat}:
 -0.9840853600948424644961729346361394995805528241884714
 -0.9061798459386639927976268782993929651256519107625304
 -0.7541667265708492204408171669461158663862998043714845
 -0.5384693101056830910363144207002088049672866069055604
 -0.2796304131617831934134665227489774362421188153561727
  0.0
```

## Quadrature rules for weighted integrals

More generally, one can compute quadrature rules for a **weighted** integral:

```math
\int_a^b W(x) f(x) dx \approx \sum_{i=1}^n w_i f(x_i)
```
where the effect of **weight function** $W(x)$ (usually required to be $≥ 0$ in ``(a,b)``) is
included in the quadrature weights $w_i$ and points $x_i$.   The main motivation
for weighted quadrature rules is to handle *poorly behaved* integrands — singular, discontinuous, highly oscillatory, and so on — where the "bad" behavior is *known*
and can be *factored out* into $W(x)$.  By designing a quadrature rule with $W(x)$
taken into account, one can obtain fast convergence as long as the remaining
factor $f(x)$ is smooth, regardless of how "bad" $W(x)$ is.  Moreover, the rule
can be re-used for many different $f(x)$ as long as $W(x)$ remains the same.

The QuadGK package can compute both Gauss and Gauss–Kronrod quadrature rules
for arbitrary weight functions $W(x)$, to arbitrary precision, as described
in the section: [Gaussian quadrature and arbitrary weight functions](@ref).

# API reference

## `quadgk`

The most commonly used function from the QuadGK package is the `quadgk` function, used to compute numerical integrals (by h-adaptive Gauss–Kronrod quadrature):

```@docs
QuadGK.quadgk
```

The `quadgk` function also has variants `quadgk_count` (which also returns a count of the integrand evaluations), `quadgk_print` (which also prints each integrand evaluation), `quadgk!` (which implements an in-place API for array-valued functions).

```@docs
QuadGK.quadgk_count
QuadGK.quadgk_print
QuadGK.quadgk!
```

For a vectorized integrand that can evaluate the integrand at multiple points
simultaneously, `quadgk` accepts a `BatchIntegrand` wrapper around the user's
integrand and pre-allocated input and output buffers.

```@docs
QuadGK.BatchIntegrand
```

The `quadgk` functions accept a `segbuf=segbuf` keyword to re-use internal
buffers from one call to the next, and an `eval_segbuf=segbuf` to re-use
the adaptive subdivision from one call to the next.   To return the internal
`segbuf` from an integration in order to re-use it, you can use the
`quadgk_segbuf` function and its variants.  You can also use the `alloc_segbuf` function to pre-allocate a segment buffer if you know the
correct numeric types for the domain endpoints, integral, and error estimate:

```@docs
QuadGK.quadgk_segbuf
QuadGK.quadgk_segbuf_count
QuadGK.quadgk_segbuf_print
QuadGK.quadgk_segbuf!
QuadGK.alloc_segbuf
```


## Gauss and Gauss–Kronrod rules

For more specialized applications, you may wish to construct your own Gauss or Gauss–Kronrod quadrature rules, as described in [Gauss and Gauss–Kronrod quadrature rules](@ref).   To compute rules for $\int_{-1}^{+1} f(x) dx$ and $\int_a^b f(x) dx$ (unweighted integrals), use:

```@docs
QuadGK.gauss(::Type{<:AbstractFloat}, ::Integer)
QuadGK.kronrod(::Type{<:AbstractFloat}, ::Integer)
```

More generally, to compute rules for $\int_a^b W(x) f(x) dx$ (weighted integrals, as described in [Gaussian quadrature and arbitrary weight functions](@ref)), use the following methods if you know the [Jacobi matrix](https://en.wikipedia.org/wiki/Jacobi_operator) for the orthogonal
polynomials associated with your weight function:

```@docs
QuadGK.gauss(::AbstractMatrix{<:Real}, ::Real)
QuadGK.kronrod(::AbstractMatrix{<:Real}, ::Integer, ::Real)
QuadGK.HollowSymTridiagonal
```

Most generally, if you know only the weight function $W(x)$ and the interval $(a,b)$, you
can construct Gauss and Gauss–Kronrod rules completely numerically using:

```@docs
QuadGK.gauss(::Any, ::Integer, ::Real, ::Real)
QuadGK.kronrod(::Any, ::Integer, ::Real, ::Real)
```
